
-- Dateiname setup_03_insert_data.sql
--
-- Beschreibung: Query zum einfügen von Daten in der Case Study DB
--
-- Autor: Andreas Zweili
-- Datum: 2017-06-05
-- Server Version: SQL Server 2016


use marketdb;
insert into dbo.member_status (status_name)
values ('new_member'),
    ('test_member'),
    ('full_member');

use marketdb;
insert into dbo.salutations (salutation_name)
values ('Herr'),
    ('Frau'),
    ('Dr.');

use marketdb;
insert into dbo.subscriptions (max_rented_locations,
                              subscription_price,
                              subscription_name,
                              duration_in_seconds)
values (1,300,'Small',15552000),
    (1,500,'Small Lungo',31536000),
    (3,500,'Grande',15552000);

use marketdb;
insert into dbo.countries (country_name)
values ('Schweiz'),
    ('Deutschland'),
    ('Österreich');

use marketdb;
insert into dbo.cities (zip_code, city_name, country_id)
values ('5000','Aarau',1),
('5001','Aarau 1 Fächer',1),
('5004','Aarau',1),
('5017','Barmelweid',1),
('5018','Erlinsbach',1),
('5022','Rombach',1),
('5023','Biberstein',1),
('5024','Küttigen',1),
('5025','Asp',1),
('5026','Densbüren',1),
('5032','Aarau Rohr',1),
('5033','Buchs AG',1),
('5034','Suhr',1),
('5035','Unterentfelden',1),
('5036','Oberentfelden',1),
('5037','Muhen',1),
('5042','Hirschthal',1),
('5722','Gränichen',1),
('5300','Turgi',1),
('5301','Siggenthal Station',1),
('5303','Würenlingen',1),
('5400','Baden',1),
('5401','Baden',1),
('5402','Baden',1),
('5404','Baden',1),
('5405','Dättwil AG',1),
('5406','Rütihof',1),
('5408','Ennetbaden',1),
('5412','Vogelsang AG',1),
('5412','Gebenstorf',1),
('5413','Birmenstorf AG',1),
('5415','Rieden AG',1),
('5415','Nussbaumen AG',1),
('5415','Hertenstein AG',1),
('5416','Kirchdorf AG',1),
('5417','Untersiggenthal',1),
('5420','Ehrendingen',1),
('5423','Freienwil',1),
('5430','Wettingen',1),
('5431','Wettingen Sonderdienste',1),
('5432','Neuenhof',1),
('5436','Würenlos',1),
('5442','Fislisbach',1),
('5443','Niederrohrdorf',1),
('5444','Künten',1),
('5452','Oberrohrdorf',1),
('5453','Remetschwil',1),
('5454','Bellikon',1),
('5506','Mägenwil',1),
('5507','Mellingen',1),
('5512','Wohlenschwil',1),
('5608','Stetten AG',1),
('8109','Kloster Fahr',1),
('8956','Killwangen',1),
('8957','Spreitenbach',1),
('8962','Bergdietikon',1),
('5445','Eggenwil',1),
('5522','Tägerig',1),
('5524','Nesselnbach',1),
('5524','Niederwil AG',1),
('5525','Fischbach-Göslikon',1),
('5605','Dottikon',1),
('5607','Hägglingen',1),
('5610','Wohlen AG',1),
('5611','Anglikon',1),
('5612','Villmergen',1),
('5613','Hilfikon',1),
('5614','Sarmenstorf',1),
('5619','Büttikon AG',1),
('5619','Uezwil',1),
('5620','Bremgarten AG',1),
('5621','Zufikon',1),
('5626','Hermetschwil-Staffeln',1),
('8905','Islisberg',1),
('8905','Arni AG',1),
('8916','Jonen',1),
('8917','Oberlunkhofen',1),
('8918','Unterlunkhofen',1),
('8964','Rudolfstetten',1),
('8965','Berikon',1),
('8966','Oberwil-Lieli',1),
('8967','Widen',1),
('5076','Bözen',1),
('5077','Elfingen',1),
('5078','Effingen',1),
('5105','Auenstein',1),
('5106','Veltheim AG',1),
('5107','Schinznach Dorf',1),
('5108','Oberflachs',1),
('5112','Thalheim AG',1),
('5116','Schinznach Bad',1),
('5200','Brugg AG',1),
('5201','Brugg AG',1),
('5210','Windisch',1),
('5212','Hausen AG',1),
('5213','Villnachern',1),
('5222','Umiken',1),
('5223','Riniken',1),
('5224','Gallenkirch',1),
('5224','Unterbözberg',1),
('5224','Linn',1),
('5225','Oberbözberg',1),
('5232','Villigen PSI',1),
('5233','Stilli',1),
('5234','Villigen',1),
('5235','Rüfenach AG',1),
('5236','Remigen',1),
('5237','Mönthal',1),
('5242','Birr',1),
('5242','Lupfig',1),
('5243','Mülligen',1),
('5244','Birrhard',1),
('5245','Habsburg',1),
('5246','Scherz',1),
('5318','Mandach',1),
('5040','Schöftland',1),
('5043','Holziken',1),
('5044','Schlossrued',1),
('5046','Walde AG',1),
('5046','Schmiedrued',1),
('5708','Birrwil',1),
('5712','Beinwil am See',1),
('5723','Teufenthal AG',1),
('5724','Dürrenäsch',1),
('5725','Leutwil',1),
('5726','Unterkulm',1),
('5727','Oberkulm',1),
('5728','Gontenschwil',1),
('5732','Zetzwil',1),
('5733','Leimbach AG',1),
('5734','Reinach AG',1),
('5736','Burg AG',1),
('5737','Menziken',1),
('4333','Münchwilen AG',1),
('4334','Sisseln AG',1),
('5027','Herznach',1),
('5028','Ueken',1),
('5062','Oberhof',1),
('5063','Wölflinswil',1),
('5064','Wittnau',1),
('5070','Frick',1),
('5072','Oeschgen',1),
('5073','Gipf-Oberfrick',1),
('5074','Eiken',1),
('5075','Hornussen',1),
('5079','Zeihen',1),
('5080','Laufenburg',1),
('5082','Kaisten',1),
('5083','Ittenthal',1),
('5084','Rheinsulz',1),
('5085','Sulz AG',1),
('5272','Gansingen',1),
('5273','Oberhofen AG',1),
('5274','Mettau',1),
('5275','Etzgen',1),
('5276','Wil AG',1),
('5277','Hottwil',1),
('5326','Schwaderloch',1),
('5102','Rupperswil',1),
('5103','Wildegg',1),
('5103','Möriken AG',1),
('5113','Holderbank AG',1),
('5502','Hunzenschwil',1),
('5503','Schafisheim',1),
('5504','Othmarsingen',1),
('5505','Brunegg',1),
('5600','Ammerswil AG',1),
('5600','Lenzburg',1),
('5601','Lenzburg Sonderdienste',1),
('5603','Staufen',1),
('5604','Hendschiken',1),
('5606','Dintikon',1),
('5615','Fahrwangen',1),
('5616','Meisterschwanden',1),
('5617','Tennwil',1),
('5702','Niederlenz',1),
('5703','Seon',1),
('5704','Egliswil',1),
('5705','Hallwil',1),
('5706','Boniswil',1),
('5707','Seengen',1),
('5618','Bettwil',1),
('5622','Waltenschwil',1),
('5623','Boswil',1),
('5624','Waldhäusern AG',1),
('5624','Bünzen',1),
('5625','Kallern',1),
('5627','Besenbüren',1),
('5628','Aristau',1),
('5630','Muri AG',1),
('5632','Buttwil',1),
('5634','Merenschwand',1),
('5636','Benzenschwil',1),
('5637','Beinwil (Freiamt)',1),
('5637','Geltwil',1),
('5642','Mühlau',1),
('5643','Meienberg',1),
('5643','Sins',1),
('5643','Alikon',1),
('5644','Auw',1),
('5645','Fenkrieden',1),
('5645','Aettenschwil',1),
('5646','Abtwil AG',1),
('5647','Oberrüti',1),
('6042','Dietwil',1),
('8919','Rottenschwil',1),
('4303','Kaiseraugst',1),
('4305','Olsberg',1),
('4310','Rheinfelden',1),
('4312','Magden',1),
('4313','Möhlin',1),
('4314','Zeiningen',1),
('4315','Zuzgen',1),
('4316','Hellikon',1),
('4317','Wegenstetten',1),
('4322','Mumpf',1),
('4323','Wallbach',1),
('4324','Obermumpf',1),
('4325','Schupfart',1),
('4332','Stein AG',1),
('4663','Aarburg',1),
('4665','Oftringen',1),
('4800','Zofingen',1),
('4801','Zofingen Ringier AG',1),
('4802','Strengelbach',1),
('4803','Vordemwald',1),
('4805','Brittnau',1),
('4807','Zofingen PostFinance',1),
('4808','Zofingen PostFinance',1),
('4809','Zofingen Postfinance UBS',1),
('4809','Zofingen PF UBS Verarb.',1),
('4812','Mühlethal',1),
('4813','Uerkheim',1),
('4814','Bottenwil',1),
('4852','Rothrist',1),
('4853','Riken AG',1),
('4853','Murgenthal',1),
('4856','Glashütten',1),
('5053','Staffelbach',1),
('5053','Wittwil',1),
('5054','Kirchleerau',1),
('5054','Moosleerau',1),
('5056','Attelwil',1),
('5057','Reitnau',1),
('5058','Wiliberg',1),
('5742','Kölliken',1),
('5745','Safenwil',1),
('5304','Endingen',1),
('5305','Unterendingen',1),
('5306','Tegerfelden',1),
('5312','Döttingen',1),
('5313','Klingnau',1),
('5314','Kleindöttingen',1),
('5315','Böttstein',1),
('5316','Leuggern',1),
('5316','Felsenau AG',1),
('5317','Hettenschwil',1),
('5322','Koblenz',1),
('5323','Rietheim',1),
('5324','Full-Reuenthal',1),
('5325','Leibstadt',1),
('5330','Bad Zurzach',1),
('5332','Rekingen AG',1),
('5333','Baldingen',1),
('5334','Böbikon',1),
('5425','Schneisingen',1),
('5426','Lengnau AG',1),
('5462','Siglistorf',1),
('5463','Wislikofen',1),
('5464','Rümikon AG',1),
('5465','Mellikon',1),
('5466','Kaiserstuhl AG',1),
('5467','Fisibach',1),
('9050','Appenzell Enggenhütten',1),
('9050','Appenzell Schlatt',1),
('9050','Appenzell Meistersrüte',1),
('9050','Appenzell',1),
('9050','Appenzell Eggerstanden',1),
('9050','Appenzell Steinegg',1),
('9050','Appenzell',1),
('9054','Haslen AI',1),
('9057','Wasserauen',1),
('9057','Weissbad',1),
('9057','Schwende',1),
('9058','Brülisau',1),
('9108','Gonten',1),
('9108','Jakobsbad',1),
('9108','Gontenbad',1),
('9413','Oberegg',1),
('9442','Büriswilen',1),
('9063','Stein AR',1),
('9064','Hundwil',1),
('9100','Herisau',1),
('9101','Herisau',1),
('9102','Herisau',1),
('9103','Schwellbrunn',1),
('9104','Waldstatt',1),
('9105','Schönengrund',1),
('9107','Urnäsch',1),
('9107','Urnäsch',1),
('9112','Schachen b. Herisau',1),
('9037','Speicherschwendi',1),
('9042','Speicher',1),
('9043','Trogen',1),
('9052','Niederteufen',1),
('9053','Teufen AR',1),
('9055','Bühler',1),
('9056','Gais',1),
('9062','Lustmühle',1),
('9035','Grub AR',1),
('9038','Rehetobel',1),
('9044','Wald AR',1),
('9405','Wienacht-Tobel',1),
('9410','Heiden',1),
('9411','Reute AR',1),
('9414','Schachen b. Reute',1),
('9426','Lutzenberg',1),
('9427','Wolfhalden',1),
('9428','Walzenhausen',1),
('2333','La Cibourg',1),
('2333','La Ferrière',1),
('2515','Prêles',1),
('2516','Lamboing',1),
('2517','Diesse',1),
('2518','Nods',1),
('2520','La Neuveville',1),
('2534','Orvin',1),
('2534','Les Prés-d''Orvin',1),
('2535','Frinvillier',1),
('2536','Plagne',1),
('2537','Vauffelin',1),
('2538','Romont BE',1),
('2603','Péry',1),
('2604','La Heutte',1),
('2605','Sonceboz-Sombeval',1),
('2606','Corgémont',1),
('2607','Cortébert',1),
('2608','Courtelary',1),
('2608','Montagne-de-Courtelary',1),
('2610','Mont-Soleil',1),
('2610','Les Pontins',1),
('2610','Mont-Crosin',1),
('2610','St-Imier',1),
('2612','Cormoret',1),
('2613','Villeret',1),
('2615','Montagne-de-Sonvilier',1),
('2615','Sonvilier',1),
('2616','La Cibourg',1),
('2616','Renan BE',1),
('2710','Tavannes',1),
('2712','Le Fuet',1),
('2713','Bellelay',1),
('2715','Châtelat',1),
('2715','Monible',1),
('2716','Sornetan',1),
('2717','Fornet-Dessous',1),
('2717','Rebévelier',1),
('2720','Tramelan',1),
('2720','La Tanne',1),
('2722','Les Reussilles',1),
('2723','Mont-Tramelan',1),
('2732','Loveresse',1),
('2732','Reconvilier',1),
('2732','Saicourt',1),
('2732','Saules BE',1),
('2733','Pontenet',1),
('2735','Champoz',1),
('2735','Bévilard',1),
('2735','Malleray',1),
('2736','Sorvilier',1),
('2738','Court',1),
('2740','Moutier',1),
('2742','Perrefitte',1),
('2743','Eschert',1),
('2744','Belprahon',1),
('2745','Grandval',1),
('2746','Crémines',1),
('2747','Corcelles BE',1),
('2747','Seehof',1),
('2748','Souboz',1),
('2748','Les Ecorcheresses',1),
('2762','Roches BE',1),
('2827','Schelten',1),
('2500','Biel/Bienne 7',1),
('2500','Biel/Bienne 4',1),
('2500','Biel/Bienne 3',1),
('2500','Biel/Bienne 1 Zustellung',1),
('2500','Biel/Bienne 6',1),
('2500','Biel/Bienne 1 Annahme',1),
('2500','Biel/Bienne',1),
('2500','Biel/Bienne 10',1),
('2500','Biel/Bienne 1',1),
('2500','Biel/Bienne 8',1),
('2501','Biel/Bienne',1),
('2502','Biel/Bienne',1),
('2503','Biel/Bienne',1),
('2504','Biel/Bienne',1),
('2505','Biel/Bienne',1),
('2510','Biel/Bienne Dist Ba',1),
('2512','Tüscherz-Alfermée',1),
('2513','Twann',1),
('2514','Ligerz',1),
('2532','Macolin',1),
('2533','Evilard',1),
('2542','Pieterlen',1),
('2543','Lengnau BE',1),
('2552','Orpund',1),
('2553','Safnern',1),
('2554','Meinisberg',1),
('2555','Brügg BE',1),
('2556','Scheuren',1),
('2556','Schwadernau',1),
('2558','Aegerten',1),
('2560','Nidau',1),
('2562','Port',1),
('2563','Ipsach',1),
('2564','Bellmund',1),
('2572','Mörigen',1),
('2572','Sutz',1),
('2557','Studen BE',1),
('2565','Jens',1),
('2575','Täuffelen',1),
('2575','Hagneck',1),
('2575','Gerolfingen',1),
('2576','Lüscherz',1),
('2577','Siselen BE',1),
('2577','Finsterhennen',1),
('3035','Frieswil',1),
('3036','Detligen',1),
('3053','Lätti',1),
('3054','Schüpfen',1),
('3225','Müntschemier',1),
('3226','Treiten',1),
('3232','Ins',1),
('3233','Tschugg',1),
('3234','Vinelz',1),
('3235','Erlach',1),
('3236','Gampelen',1),
('3237','Brüttelen',1),
('3238','Gals',1),
('3250','Lyss',1),
('3251','Ruppoldsried',1),
('3251','Wengi b. Büren',1),
('3252','Worben',1),
('3255','Rapperswil BE',1),
('3256','Seewil',1),
('3256','Dieterswil',1),
('3256','Bangerten b. Dieterswil',1),
('3257','Ammerzwil BE',1),
('3257','Grossaffoltern',1),
('3262','Suberg',1),
('3263','Büetigen',1),
('3264','Diessbach b. Büren',1),
('3266','Wiler b. Seedorf',1),
('3267','Seedorf BE',1),
('3268','Lobsigen',1),
('3270','Aarberg',1),
('3271','Radelfingen b. Aarberg',1),
('3272','Epsach',1),
('3272','Walperswil',1),
('3273','Kappelen',1),
('3274','Merzligen',1),
('3274','Bühl b. Aarberg',1),
('3274','Hermrigen',1),
('3282','Bargen BE',1),
('3283','Niederried b. Kallnach',1),
('3283','Kallnach',1),
('3292','Busswil BE',1),
('3293','Dotzigen',1),
('3294','Büren an der Aare',1),
('3294','Meienried',1),
('3295','Rüti b. Büren',1),
('3296','Arch',1),
('3297','Leuzigen',1),
('3298','Oberwil b. Büren',1),
('3360','Herzogenbuchsee',1),
('3362','Niederönz',1),
('3363','Oberönz',1),
('3365','Grasswil',1),
('3365','Seeberg',1),
('3366','Bettenhausen',1),
('3366','Bollodingen',1),
('3367','Ochlenberg',1),
('3367','Thörigen',1),
('3368','Bleienbach',1),
('3372','Wanzwil',1),
('3373','Heimenhausen',1),
('3373','Röthenbach Herzogenbuchsee',1),
('3374','Wangenried',1),
('3375','Inkwil',1),
('3376','Berken',1),
('3376','Graben',1),
('3377','Walliswil b. Wangen',1),
('3380','Wangen an der Aare',1),
('3380','Walliswil b. Niederbipp',1),
('3464','Schmidigen-Mühleweg',1),
('3475','Hermiswil',1),
('3475','Riedtwil',1),
('3476','Oschwand',1),
('4536','Attiswil',1),
('4537','Wiedlisbach',1),
('4538','Oberbipp',1),
('4539','Farnern',1),
('4539','Rumisberg',1),
('4704','Niederbipp',1),
('4704','Wolfisberg',1),
('4900','Langenthal',1),
('4901','Langenthal',1),
('4902','Langenthal',1),
('4911','Schwarzhäusern',1),
('4912','Aarwangen',1),
('4913','Bannwil',1),
('4914','Roggwil BE',1),
('4916','Untersteckholz',1),
('4917','Busswil b. Melchnau',1),
('4917','Melchnau',1),
('4919','Reisiswil',1),
('4922','Bützberg',1),
('4922','Thunstetten',1),
('4923','Wynau',1),
('4924','Obersteckholz',1),
('4932','Lotzwil',1),
('4932','Gutenburg',1),
('4933','Rütschelen',1),
('4934','Madiswil',1),
('4935','Leimiswil',1),
('4936','Kleindietwil',1),
('4937','Ursenbach',1),
('4938','Rohrbach',1),
('4938','Rohrbachgraben',1),
('4942','Walterswil BE',1),
('4943','Oeschenbach',1),
('4944','Auswil',1),
('4950','Huttwil',1),
('4952','Eriswil',1),
('4953','Schwarzenbach (Huttwil)',1),
('4954','Wyssachen',1),
('4955','Gondiswil',1),
('3309','Kernenried',1),
('3315','Kräiligen',1),
('3315','Bätterkinden',1),
('3324','Mötschwil',1),
('3324','Hindelbank',1),
('3325','Hettiswil b. Hindelbank',1),
('3326','Krauchthal',1),
('3400','Burgdorf',1),
('3401','Burgdorf',1),
('3402','Burgdorf',1),
('3412','Heimiswil',1),
('3413','Kaltacker',1),
('3414','Oberburg',1),
('3415','Schafhausen im Emmental',1),
('3415','Rüegsauschachen',1),
('3415','Hasle b. Burgdorf',1),
('3416','Affoltern im Emmental',1),
('3417','Rüegsau',1),
('3418','Rüegsbach',1),
('3419','Biembach im Emmental',1),
('3421','Rüti b. Lyssach',1),
('3421','Lyssach',1),
('3422','Kirchberg BE',1),
('3422','Rüdtligen',1),
('3422','Alchenflüh',1),
('3423','Ersigen',1),
('3424','Oberösch',1),
('3424','Niederösch',1),
('3425','Koppigen',1),
('3425','Willadingen',1),
('3426','Aefligen',1),
('3427','Utzenstorf',1),
('3428','Wiler b. Utzenstorf',1),
('3429','Höchstetten',1),
('3429','Hellsau',1),
('3432','Lützelflüh-Goldbach',1),
('3433','Schwanden im Emmental',1),
('3435','Ramsei',1),
('3436','Zollbrück',1),
('3437','Rüderswil',1),
('3438','Lauperswil',1),
('3439','Ranflüh',1),
('3452','Grünenmatt',1),
('3453','Heimisbach',1),
('3454','Sumiswald',1),
('3455','Grünen',1),
('3456','Trachselwald',1),
('3457','Wasen im Emmental',1),
('3462','Weier im Emmental',1),
('3463','Häusernmoos im Emmental',1),
('3465','Dürrenroth',1),
('3472','Wynigen',1),
('3472','Rumendingen',1),
('3473','Alchenstorf',1),
('3474','Rüedisbach',1),
('3534','Signau',1),
('3535','Schüpbach',1),
('3536','Aeschau',1),
('3537','Eggiwil',1),
('3538','Röthenbach im Emmental',1),
('3543','Emmenmatt',1),
('3550','Langnau im Emmental',1),
('3551','Oberfrittenbach',1),
('3552','Bärau',1),
('3553','Gohl',1),
('3555','Trubschachen',1),
('3556','Trub',1),
('3557','Fankhaus (Trub)',1),
('4564','Zielebach',1),
('6197','Schangnau',1),
('1595','Clavaleyres',1),
('1738','Sangernboden',1),
('1797','Münchenwiler',1),
('3000','Bern Radio Schweiz',1),
('3000','Bern 71 CS PZ',1),
('3000','Bern 60 UPD',1),
('3000','Bern 6',1),
('3000','Bern Brünnen',1),
('3000','Bern 1 Schanzenpost',1),
('3000','Bern 7 Bärenplatz',1),
('3000','Bern 90',1),
('3000','Bern 8',1),
('3000','Bern 31',1),
('3000','Bern Postauto BE-FB-SO',1),
('3000','Bern 14',1),
('3000','Bern 21',1),
('3000','Bern 22',1),
('3000','Bern 77 SBV',1),
('3000','Bern 94 UBS',1),
('3000','Bern 22 Kaserne',1),
('3000','Bern 9',1),
('3000','Bern 5',1),
('3000','Bern 13',1),
('3000','Bern 25',1),
('3000','Bern 15',1),
('3000','Bern 23',1),
('3000','Bern',1),
('3000','Bern 65 SBB',1),
('3001','Bern',1),
('3002','Bern Postfinance',1),
('3003','Bern 3 Nationalrat',1),
('3003','Bern',1),
('3003','Bern 3 Ständerat',1),
('3004','Bern',1),
('3005','Bern',1),
('3006','Bern',1),
('3007','Bern',1),
('3008','Bern',1),
('3010','Bern',1),
('3011','Bern',1),
('3012','Bern',1),
('3013','Bern',1),
('3014','Bern',1),
('3015','Bern',1),
('3017','Bern Zustellung',1),
('3018','Bern',1),
('3019','Bern',1),
('3020','Bern',1),
('3024','Bern',1),
('3027','Bern',1),
('3029','Bern Entris',1),
('3030','Bern KC PK 4',1),
('3030','Bern Logistikcenter',1),
('3030','Bern',1),
('3030','Bern KC PK 5',1),
('3032','Hinterkappelen',1),
('3033','Wohlen b. Bern',1),
('3034','Murzelen',1),
('3037','Herrenschwanden',1),
('3038','Kirchlindach',1),
('3039','Bern PF Operations Center',1),
('3040','Bern',1),
('3041','Bern UBS',1),
('3042','Ortschwaben',1),
('3043','Uettligen',1),
('3044','Innerberg',1),
('3045','Meikirch',1),
('3046','Wahlendorf',1),
('3047','Bremgarten b. Bern',1),
('3048','Worblaufen',1),
('3049','Säriswil',1),
('3050','Bern Swisscom',1),
('3050','Bern DocumentServices',1),
('3052','Zollikofen',1),
('3053','Wiggiswil',1),
('3053','Münchenbuchsee',1),
('3053','Deisswil b. Münchenbuchsee',1),
('3053','Diemerswil',1),
('3063','Ittigen',1),
('3065','Bolligen',1),
('3066','Stettlen',1),
('3067','Boll',1),
('3068','Utzigen',1),
('3070','Ostermundigen LZB BHS-AF',1),
('3070','Ostermundigen (LZB)',1),
('3071','Ostermundigen Zustellung',1),
('3071','Ostermundigen Dist Ba',1),
('3071','Ostermundigen KATA',1),
('3072','Ostermundigen',1),
('3073','Gümligen',1),
('3074','Muri b. Bern',1),
('3075','Vielbringen b. Worb',1),
('3075','Rüfenacht BE',1),
('3076','Worb',1),
('3077','Enggistein',1),
('3078','Richigen',1),
('3082','Schlosswil',1),
('3083','Trimstein',1),
('3084','Wabern',1),
('3085','Wabern 2 x Weihnachten',1),
('3086','Englisberg',1),
('3086','Zimmerwald',1),
('3087','Niedermuhlern',1),
('3088','Oberbütschel',1),
('3088','Rüeggisberg',1),
('3089','Hinterfultigen',1),
('3095','Spiegel b. Bern',1),
('3096','Oberbalm',1),
('3097','Liebefeld',1),
('3098','Schliern b. Köniz',1),
('3098','Köniz',1),
('3099','Rüti b. Riggisberg',1),
('3110','Münsingen',1),
('3111','Tägertschi',1),
('3112','Allmendingen b. Bern',1),
('3113','Rubigen',1),
('3114','Wichtrach',1),
('3115','Gerzensee',1),
('3116','Noflen BE',1),
('3116','Mühledorf BE',1),
('3116','Kirchdorf BE',1),
('3122','Kehrsatz',1),
('3123','Belp',1),
('3124','Belpberg',1),
('3125','Toffen',1),
('3126','Gelterfingen',1),
('3126','Kaufdorf',1),
('3127','Lohnstorf',1),
('3127','Mühlethurnen',1),
('3128','Kirchenthurnen',1),
('3128','Rümligen',1),
('3132','Riggisberg',1),
('3144','Gasel',1),
('3145','Niederscherli',1),
('3147','Mittelhäusern',1),
('3148','Lanzenhäusern',1),
('3150','Schwarzenburg',1),
('3152','Mamishaus',1),
('3153','Rüschegg Gambach',1),
('3154','Rüschegg Heubach',1),
('3155','Helgisried-Rohrbach',1),
('3156','Riffenmatt',1),
('3157','Milken',1),
('3158','Guggisberg',1),
('3159','Riedstätt',1),
('3172','Niederwangen b. Bern',1),
('3173','Oberwangen b. Bern',1),
('3174','Thörishaus',1),
('3176','Neuenegg',1),
('3177','Laupen BE',1),
('3179','Kriechenwil',1),
('3183','Albligen',1),
('3202','Frauenkappelen',1),
('3203','Mühleberg',1),
('3204','Rosshäusern',1),
('3205','Gümmenen',1),
('3206','Ferenbalm',1),
('3206','Rizenbach',1),
('3206','Biberen',1),
('3206','Gammen',1),
('3207','Golaten',1),
('3207','Wileroltigen',1),
('3208','Gurbrü',1),
('3302','Moosseedorf',1),
('3303','Münchringen',1),
('3303','Zuzwil BE',1),
('3303','Jegenstorf',1),
('3303','Ballmoos',1),
('3305','Scheunen',1),
('3305','Iffwil',1),
('3306','Etzelkofen',1),
('3308','Grafenried',1),
('3309','Zauggenried',1),
('3312','Fraubrunnen',1),
('3313','Büren zum Hof',1),
('3314','Schalunen',1),
('3317','Mülchi',1),
('3317','Limpach',1),
('3321','Schönbühl Einkaufszentrum',1),
('3322','Urtenen-Schönbühl',1),
('3322','Mattstetten',1),
('3323','Bäriswil BE',1),
('3434','Obergoldbach',1),
('3434','Landiswil',1),
('3503','Gysenstein',1),
('3504','Oberhünigen',1),
('3504','Niederhünigen',1),
('3506','Grosshöchstetten',1),
('3507','Biglen',1),
('3508','Arni BE',1),
('3510','Häutligen',1),
('3510','Konolfingen',1),
('3510','Freimettigen',1),
('3512','Walkringen',1),
('3513','Bigenthal',1),
('3531','Oberthal',1),
('3532','Zäziwil',1),
('3532','Mirchel',1),
('3533','Bowil',1),
('3629','Kiesen',1),
('3629','Oppligen',1),
('3629','Jaberg',1),
('3671','Herbligen',1),
('3671','Brenzikofen',1),
('3672','Oberdiessbach',1),
('3672','Aeschlen b. Oberdiessbach',1),
('3673','Linden',1),
('3674','Bleiken b. Oberdiessbach',1),
('3600','Thun',1),
('3601','Thun',1),
('3602','Thun',1),
('3603','Thun',1),
('3604','Thun',1),
('3605','Thun',1),
('3607','Thun',1),
('3608','Thun',1),
('3609','Thun',1),
('3612','Steffisburg',1),
('3613','Steffisburg',1),
('3614','Unterlangenegg',1),
('3615','Heimenschwand',1),
('3616','Schwarzenegg',1),
('3617','Fahrni b. Thun',1),
('3618','Süderen',1),
('3619','Innereriz',1),
('3619','Eriz',1),
('3622','Homberg b. Thun',1),
('3623','Buchen BE',1),
('3623','Horrenbach',1),
('3623','Teuffenthal b. Thun',1),
('3624','Schwendibach',1),
('3624','Goldiwil (Thun)',1),
('3625','Heiligenschwendi',1),
('3626','Hünibach',1),
('3627','Heimberg',1),
('3628','Kienersrüti',1),
('3628','Uttigen',1),
('3631','Höfen b. Thun',1),
('3632','Oberstocken',1),
('3632','Niederstocken',1),
('3633','Amsoldingen',1),
('3634','Thierachern',1),
('3635','Uebeschi',1),
('3636','Längenbühl',1),
('3636','Forst b. Längenbühl',1),
('3638','Pohlern',1),
('3638','Blumenstein',1),
('3645','Gwatt (Thun)',1),
('3645','Zwieselberg',1),
('3647','Reutigen',1),
('3652','Hilterfingen',1),
('3653','Oberhofen am Thunersee',1),
('3654','Gunten',1),
('3655','Sigriswil',1),
('3656','Tschingel ob Gunten',1),
('3656','Ringoldswil',1),
('3656','Aeschlen ob Gunten',1),
('3657','Schwanden (Sigriswil)',1),
('3658','Merligen',1),
('3661','Uetendorf',1),
('3662','Seftigen',1),
('3663','Gurzelen',1),
('3664','Burgistein',1),
('3665','Wattenwil',1),
('1657','Abländschen',1),
('3766','Boltigen',1),
('3770','Zweisimmen',1),
('3771','Blankenburg',1),
('3772','St. Stephan',1),
('3773','Matten (St. Stephan)',1),
('3775','Lenk im Simmental',1),
('3776','Oeschseite',1),
('3777','Saanenmöser',1),
('3778','Schönried',1),
('3780','Gstaad',1),
('3781','Turbach',1),
('3782','Lauenen b. Gstaad',1),
('3783','Grund b. Gstaad',1),
('3784','Feutersoey',1),
('3785','Gsteig b. Gstaad',1),
('3792','Saanen',1),
('3646','Einigen',1),
('3700','Spiez',1),
('3702','Hondrich',1),
('3703','Aeschiried',1),
('3703','Aeschi b. Spiez',1),
('3704','Krattigen',1),
('3705','Faulensee',1),
('3711','Mülenen',1),
('3711','Emdthal',1),
('3713','Reichenbach im Kandertal',1),
('3714','Wengi b. Frutigen',1),
('3714','Frutigen',1),
('3715','Adelboden',1),
('3716','Kandergrund',1),
('3717','Blausee-Mitholz',1),
('3718','Kandersteg',1),
('3722','Scharnachtal',1),
('3723','Kiental',1),
('3724','Ried (Frutigen)',1),
('3725','Achseten',1),
('3752','Wimmis',1),
('3753','Oey',1),
('3754','Diemtigen',1),
('3755','Horboden',1),
('3756','Zwischenflüh',1),
('3757','Schwenden im Diemtigtal',1),
('3758','Latterbach',1),
('3762','Erlenbach im Simmental',1),
('3763','Därstetten',1),
('3764','Weissenburg',1),
('3765','Oberwil im Simmental',1),
('3706','Leissigen',1),
('3707','Därligen',1),
('3800','Matten b. Interlaken',1),
('3800','Sundlauenen',1),
('3800','Interlaken',1),
('3800','Unterseen',1),
('3803','Beatenberg',1),
('3804','Habkern',1),
('3805','Goldswil b. Interlaken',1),
('3806','Bönigen b. Interlaken',1),
('3807','Iseltwald',1),
('3812','Wilderswil',1),
('3813','Saxeten',1),
('3814','Gsteigwiler',1),
('3815','Gündlischwand',1),
('3815','Zweilütschinen',1),
('3816','Burglauenen',1),
('3816','Lütschental',1),
('3818','Grindelwald',1),
('3822','Isenfluh',1),
('3822','Lauterbrunnen',1),
('3823','Wengen',1),
('3823','Kleine Scheidegg',1),
('3823','Eigergletscher',1),
('3824','Stechelberg',1),
('3825','Mürren',1),
('3826','Gimmelwald',1),
('3852','Ringgenberg BE',1),
('3853','Niederried b. Interlaken',1),
('3854','Oberried am Brienzersee',1),
('3855','Schwanden b. Brienz',1),
('3855','Axalp',1),
('3855','Brienz BE',1),
('3856','Brienzwiler',1),
('3857','Unterbach BE',1),
('3858','Hofstetten b. Brienz',1),
('3860','Rosenlaui',1),
('3860','Brünig',1),
('3860','Meiringen',1),
('3860','Schattenhalb',1),
('3862','Innertkirchen',1),
('3863','Gadmen',1),
('3864','Guttannen',1),
('6083','Hasliberg Hohfluh',1),
('6084','Hasliberg Wasserwendi',1),
('6085','Hasliberg Goldern',1),
('6086','Hasliberg Reuti',1),
('4023','Basel',1),
('4040','Basel',1),
('4042','Basel PF Operations Center',1),
('4101','Bruderholz',1),
('4102','Binningen',1),
('4103','Bottmingen',1),
('4104','Oberwil BL',1),
('4105','Biel-Benken BL',1),
('4106','Therwil',1),
('4107','Ettingen',1),
('4123','Allschwil',1),
('4124','Schönenbuch',1),
('4127','Birsfelden',1),
('4132','Muttenz',1),
('4142','Münchenstein',1),
('4144','Arlesheim',1),
('4147','Aesch BL',1),
('4148','Pfeffingen',1),
('4153','Reinach BL',1),
('2814','Roggenburg',1),
('4117','Burg im Leimental',1);

use marketdb;
insert into dbo.cities (zip_code, city_name, country_id)
values ('4202','Duggingen',1),
('4203','Grellingen',1),
('4222','Zwingen',1),
('4223','Blauen',1),
('4224','Nenzlingen',1),
('4225','Brislach',1),
('4242','Laufen',1),
('4243','Dittingen',1),
('4244','Röschenz',1),
('4246','Wahlen b. Laufen',1),
('4253','Liesberg',1),
('4254','Liesberg Dorf',1),
('4133','Pratteln',1),
('4302','Augst BL',1),
('4304','Giebenach',1),
('4402','Frenkendorf',1),
('4410','Liestal',1),
('4411','Seltisberg',1),
('4414','Füllinsdorf',1),
('4415','Lausen',1),
('4416','Bubendorf',1),
('4417','Ziefen',1),
('4419','Lupsingen',1),
('4422','Arisdorf',1),
('4423','Hersberg',1),
('4433','Ramlinsburg',1),
('4441','Thürnen',1),
('4442','Diepflingen',1),
('4443','Wittinsburg',1),
('4444','Rümlingen',1),
('4445','Häfelfingen',1),
('4446','Buckten',1),
('4447','Känerkinden',1),
('4448','Läufelfingen',1),
('4450','Sissach',1),
('4451','Wintersingen',1),
('4452','Itingen',1),
('4453','Nusshof',1),
('4455','Zunzgen',1),
('4456','Tenniken',1),
('4460','Gelterkinden',1),
('4461','Böckten',1),
('4462','Rickenbach BL',1),
('4463','Buus',1),
('4464','Maisprach',1),
('4465','Hemmiken',1),
('4466','Ormalingen',1),
('4467','Rothenfluh',1),
('4469','Anwil',1),
('4492','Tecknau',1),
('4493','Wenslingen',1),
('4494','Oltingen',1),
('4495','Zeglingen',1),
('4496','Kilchberg BL',1),
('4497','Rünenberg',1),
('4207','Bretzwil',1),
('4418','Reigoldswil',1),
('4424','Arboldswil',1),
('4425','Titterten',1),
('4426','Lauwil',1),
('4431','Bennwil',1),
('4432','Lampenberg',1),
('4434','Hölstein',1),
('4435','Niederdorf',1),
('4436','Liedertswil',1),
('4436','Oberdorf BL',1),
('4437','Waldenburg',1),
('4438','Langenbruck',1),
('4457','Diegten',1),
('4458','Eptingen',1),
('4000','Basel',1),
('4000','Basel 2 Zustellung',1),
('4000','Basel Dist Ba',1),
('4000','Basel Postauto Nordwestschw',1),
('4001','Basel',1),
('4002','Basel 2 Annahme',1),
('4002','Basel Logistikzentrum',1),
('4002','Basel',1),
('4003','Basel',1),
('4004','Basel',1),
('4005','Basel',1),
('4007','Basel',1),
('4008','Basel',1),
('4009','Basel',1),
('4010','Basel',1),
('4011','Basel',1),
('4012','Basel',1),
('4013','Basel Voltaplatz',1),
('4013','Basel',1),
('4015','Basel',1),
('4016','Basel',1),
('4017','Basel',1),
('4018','Basel',1),
('4019','Basel',1),
('4020','Basel',1),
('4024','Basel',1),
('4025','Basel',1),
('4030','Basel',1),
('4031','Basel Universitätsspital',1),
('4032','Basel',1),
('4033','Basel Novartis Campus',1),
('4034','Basel 34 Breite',1),
('4035','Basel 35 Bäumlihof',1),
('4039','Basel',1),
('4041','Basel UBS',1),
('4051','Basel',1),
('4052','Basel',1),
('4052','Basel',1),
('4053','Basel',1),
('4054','Basel',1),
('4055','Basel',1),
('4056','Basel',1),
('4057','Basel',1),
('4058','Basel',1),
('4059','Basel',1),
('4065','Basel SBB Cargo AG',1),
('4070','Basel',1),
('4075','Basel',1),
('4078','Basel Reader''s Digest',1),
('4080','Basel',1),
('4081','Basel SPI AS1',1),
('4082','Basel SPI AS2',1),
('4083','Basel',1),
('4084','Basel',1),
('4085','Basel',1),
('4086','Basel',1),
('4087','Basel',1),
('4088','Basel',1),
('4089','Basel SPILOG',1),
('4089','Basel SPI GLS Retour',1),
('4091','Basel',1),
('4092','Basel SPI AS 22',1),
('4093','Basel SPI AS 23',1),
('4094','Basel SPI AS 24',1),
('4095','Basel SPI AS 25',1),
('4096','Basel SPI AS 26',1),
('4125','Riehen',1),
('4126','Bettingen',1),
('1410','Prévondavaux',1),
('1468','Cheyres',1),
('1470','Lully FR',1),
('1470','Estavayer-le-Lac',1),
('1470','Bollion',1),
('1470','Seiry',1),
('1473','Châtillon FR',1),
('1473','Font',1),
('1474','Châbles FR',1),
('1475','Forel FR',1),
('1475','Autavaux',1),
('1475','Montbrelloz',1),
('1482','Cugy FR',1),
('1483','Frasses',1),
('1483','Montet (Broye)',1),
('1483','Vesin',1),
('1484','Aumont',1),
('1484','Granges-de-Vesin',1),
('1485','Nuvilly',1),
('1486','Vuissens',1),
('1489','Murist',1),
('1527','Villeneuve FR',1),
('1528','Praratoud',1),
('1528','Surpierre',1),
('1529','Cheiry',1),
('1532','Fétigny',1),
('1533','Ménières',1),
('1534','Chapelle (Broye)',1),
('1541','Bussy FR',1),
('1541','Sévaz',1),
('1541','Morens FR',1),
('1542','Rueyres-les-Prés',1),
('1544','Gletterens',1),
('1563','Dompierre FR',1),
('1564','Domdidier',1),
('1565','Vallon',1),
('1566','St-Aubin FR',1),
('1566','Les Friques',1),
('1567','Delley',1),
('1568','Portalban',1),
('1773','Russy',1),
('1773','Chandon',1),
('1773','Léchelles',1),
('1774','Montagny-les-Monts',1),
('1774','Cousset',1),
('1775','Grandsivaz',1),
('1775','Mannens',1),
('1776','Montagny-la-Ville',1),
('1553','Châtonnaye',1),
('1608','Chapelle (Glâne)',1),
('1670','Ursy',1),
('1670','Esmonts',1),
('1670','Bionnens',1),
('1673','Gillarens',1),
('1673','Rue',1),
('1673','Ecublens FR',1),
('1673','Promasens',1),
('1673','Auboranges',1),
('1674','Vuarmarens',1),
('1674','Morlens',1),
('1674','Montet (Glâne)',1),
('1675','Blessens',1),
('1675','Vauderens',1),
('1675','Mossel',1),
('1676','Chavannes-les-Forts',1),
('1677','Prez-vers-Siviriez',1),
('1678','Siviriez',1),
('1679','Villaraboud',1),
('1680','Berlens',1),
('1680','Romont FR',1),
('1681','Billens',1),
('1681','Hennens',1),
('1684','Mézières FR',1),
('1685','Villariaz',1),
('1686','La Neirigue',1),
('1686','Grangettes-près-Romont',1),
('1687','Estévenens',1),
('1687','Vuisternens-devant-Romont',1),
('1687','La Magne',1),
('1688','Sommentier',1),
('1688','Lieffrens',1),
('1689','Le Châtelard-près-Romont',1),
('1690','Villaz-St-Pierre',1),
('1690','Lussy FR',1),
('1691','Villarimboud',1),
('1692','Massonnens',1),
('1694','Chavannes-sous-Orsonnens',1),
('1694','Villarsiviriaux',1),
('1694','Orsonnens',1),
('1694','Villargiroud',1),
('1697','Les Ecasseys',1),
('1697','La Joux FR',1),
('1748','Torny-le-Grand',1),
('1749','Middes',1),
('1625','Sâles (Gruyère)',1),
('1625','Maules',1),
('1626','Rueyres-Treyfayes',1),
('1626','Treyfayes',1),
('1626','Romanens',1),
('1627','Vaulruz',1),
('1628','Vuadens',1),
('1630','Bulle',1),
('1631','Bulle',1),
('1632','Riaz',1),
('1633','Vuippens',1),
('1633','Marsens',1),
('1634','La Roche FR',1),
('1635','La Tour-de-Trême',1),
('1636','Broc',1),
('1637','Charmey (Gruyère)',1),
('1638','Morlon',1),
('1642','Sorens',1),
('1643','Gumefens',1),
('1644','Avry-devant-Pont',1),
('1645','Le Bry',1),
('1646','Echarlens',1),
('1647','Corbières',1),
('1648','Hauteville',1),
('1649','Pont-la-Ville',1),
('1651','Villarvolard',1),
('1652','Villarbeney',1),
('1652','Botterens',1),
('1653','Châtel-sur-Montsalvens',1),
('1653','Crésuz',1),
('1654','Cerniat FR',1),
('1656','Jaun',1),
('1656','Im Fang',1),
('1661','Le Pâquier-Montbarry',1),
('1663','Gruyères',1),
('1663','Epagny',1),
('1663','Pringy',1),
('1663','Moléson-sur-Gruyères',1),
('1665','Estavannens',1),
('1666','Villars-sous-Mont',1),
('1666','Grandvillard',1),
('1667','Enney',1),
('1669','Albeuve',1),
('1669','Neirivue',1),
('1669','Les Sciernes-d''Albeuve',1),
('1669','Montbovon',1),
('1669','Lessoc',1),
('1695','Villarlod',1),
('1695','Rueyres-St-Laurent',1),
('1695','Villarsel-le-Gibloux',1),
('1695','Estavayer-le-Gibloux',1),
('1696','Vuisternens-en-Ogoz',1),
('1700','Fribourg',1),
('1701','Fribourg',1),
('1702','Fribourg',1),
('1704','Fribourg',1),
('1705','Fribourg',1),
('1707','Fribourg',1),
('1708','Fribourg',1),
('1709','Fribourg',1),
('1720','Corminboeuf',1),
('1720','Chésopelloz',1),
('1722','Bourguillon',1),
('1723','Pierrafortscha',1),
('1723','Villarsel-sur-Marly',1),
('1723','Marly',1),
('1724','Essert FR',1),
('1724','Le Mouret',1),
('1724','Montévraz',1),
('1724','Zénauva',1),
('1724','Bonnefontaine',1),
('1724','Oberried FR',1),
('1724','Ferpicloz',1),
('1724','Senèdes',1),
('1725','Posieux',1),
('1726','Posat',1),
('1726','Farvagny-le-Petit',1),
('1726','Farvagny',1),
('1726','Grenilles',1),
('1727','Corpataux-Magnedens',1),
('1727','Magnedens',1),
('1728','Rossens FR',1),
('1730','Ecuvillens',1),
('1731','Ependes FR',1),
('1732','Arconciel',1),
('1733','Treyvaux',1),
('1740','Neyruz FR',1),
('1741','Cottens FR',1),
('1742','Autigny',1),
('1744','Chénens',1),
('1745','Lentigny',1),
('1746','Prez-vers-Noréaz',1),
('1747','Corserey',1),
('1752','Villars-sur-Glâne',1),
('1753','Matran',1),
('1754','Avry-Centre FR',1),
('1754','Corjolens',1),
('1754','Rosé',1),
('1754','Avry-sur-Matran',1),
('1756','Lovens',1),
('1756','Onnens FR',1),
('1757','Noréaz',1),
('1762','Givisiez',1),
('1763','Granges-Paccot',1),
('1772','Ponthaux',1),
('1772','Grolley',1),
('1772','Nierlet-les-Bois',1),
('1782','Formangueires',1),
('1782','Cormagens',1),
('1782','Lossy',1),
('1782','La Corbaz',1),
('1782','Belfaux',1),
('1782','Autafond',1),
('1583','Villarepos',1),
('1721','Cormérod',1),
('1721','Misery',1),
('1721','Courtion',1),
('1783','Barberêche',1),
('1783','Pensier',1),
('1784','Courtepin',1),
('1784','Wallenried',1),
('1784','Cournillens',1),
('1785','Cressier FR',1),
('1786','Sugiez',1),
('1787','Mur (Vully) FR',1),
('1787','Môtier (Vully)',1),
('1788','Praz (Vully)',1),
('1789','Lugnorre',1),
('1791','Courtaman',1),
('1792','Guschelmuth',1),
('1792','Cordast',1),
('1793','Jeuss',1),
('1794','Salvenach',1),
('1795','Courlevon',1),
('1796','Courgevaux',1),
('3206','Wallenbuch',1),
('3210','Kerzers',1),
('3212','Gurmels',1),
('3212','Kleingurmels',1),
('3213','Kleinbösingen',1),
('3213','Liebistorf',1),
('3214','Ulmiz',1),
('3215','Büchslen',1),
('3215','Gempenach',1),
('3215','Lurtigen',1),
('3216','Ried b. Kerzers',1),
('3216','Agriswil',1),
('3280','Greng',1),
('3280','Murten',1),
('3280','Meyriez',1),
('3284','Fräschels',1),
('3285','Galmiz',1),
('3286','Muntelier',1),
('1712','Tafers',1),
('1713','St. Antoni',1),
('1714','Heitenried',1),
('1715','Alterswil FR',1),
('1716','Plaffeien',1),
('1716','Schwarzsee',1),
('1716','Oberschrot',1),
('1717','St. Ursen',1),
('1718','Rechthalten',1),
('1719','Brünisried',1),
('1719','Zumholz',1),
('1734','Tentlingen',1),
('1735','Giffers',1),
('1736','St. Silvester',1),
('1737','Plasselb',1),
('3175','Flamatt',1),
('3178','Bösingen',1),
('3182','Ueberstorf',1),
('3184','Wünnewil',1),
('3185','Schmitten FR',1),
('3186','Düdingen',1),
('1609','St-Martin FR',1),
('1609','Fiaugères',1),
('1609','Besencens',1),
('1609','Fiaugères',1),
('1611','Le Crêt-près-Semsales',1),
('1614','Granges (Veveyse)',1),
('1615','Bossonnens',1),
('1616','Attalens',1),
('1617','Tatroz',1),
('1617','Remaufens',1),
('1618','Châtel-St-Denis',1),
('1619','Les Paccots',1),
('1623','Semsales',1),
('1624','La Verrerie',1),
('1624','Progens',1),
('1624','Grattavache',1),
('1699','Pont (Veveyse)',1),
('1699','Porsel',1),
('1699','Bouloz',1),
('1200','Genève 20',1),
('1200','Genève 18',1),
('1200','Genève 8',1),
('1200','Genève 13',1),
('1200','Genève 3',1),
('1200','Genève 2 Cornavin Dépôt',1),
('1200','Genève 11',1),
('1200','Genève 2 Transit',1),
('1200','Genève Centre logistique',1),
('1200','Genève 7',1),
('1200','Genève 6',1),
('1200','Genève 2 Distribution',1),
('1200','Genève 17',1),
('1200','Genève Les Acacias',1),
('1200','Genève 4',1),
('1200','Genève',1),
('1200','Genève 19',1),
('1200','Genève 21',1),
('1200','Genève 1',1),
('1200','Genève 12',1),
('1200','Genève 26',1),
('1200','Genève Dist Ba',1),
('1200','Genève 28 Balexert',1),
('1201','Genève',1),
('1202','Genève',1),
('1203','Genève',1),
('1204','Genève',1),
('1205','Genève',1),
('1206','Genève',1),
('1207','Genève',1),
('1208','Genève',1),
('1209','Genève',1),
('1211','Genève 3',1),
('1211','Genève 10',1),
('1211','Genève 14',1),
('1211','Genève 6',1),
('1211','Genève 73',1),
('1211','Genève 2 Swisscom',1),
('1211','Genève 28',1),
('1211','Genève 19',1),
('1211','Genève 84 Votations',1),
('1211','Genève 17',1),
('1211','Genève 8',1),
('1211','Genève 13',1),
('1211','Genève 26',1),
('1211','Genève 71 CS CP',1),
('1211','Genève 11',1),
('1211','Genève 27',1),
('1211','Genève 20',1),
('1211','Genève 26 Caserne',1),
('1211','Genève 94 UBS',1),
('1211','Genève 5',1),
('1211','Genève 23',1),
('1211','Genève 4',1),
('1211','Genève 5 Dépôt',1),
('1211','Genève 70',1),
('1211','Genève 12',1),
('1211','Genève 21',1),
('1211','Genève 2',1),
('1211','Genève 1',1),
('1211','Genève 7',1),
('1211','Genève 22',1),
('1212','Grand-Lancy',1),
('1213','Petit-Lancy',1),
('1213','Onex',1),
('1214','Vernier',1),
('1215','Genève',1),
('1216','Cointrin',1),
('1217','Meyrin',1),
('1218','Le Grand-Saconnex',1),
('1219','Aïre',1),
('1219','Le Lignon',1),
('1219','Châtelaine',1),
('1220','Les Avanchets',1),
('1222','Vésenaz',1),
('1223','Cologny',1),
('1224','Chêne-Bougeries',1),
('1225','Chêne-Bourg',1),
('1226','Thônex',1),
('1227','Les Acacias',1),
('1227','Carouge GE',1),
('1228','Plan-les-Ouates',1),
('1231','Conches',1),
('1232','Confignon',1),
('1233','Bernex',1),
('1234','Vessy',1),
('1236','Cartigny',1),
('1237','Avully',1),
('1239','Collex',1),
('1240','Genève',1),
('1241','Puplinge',1),
('1242','Satigny',1),
('1243','Presinge',1),
('1244','Choulex',1),
('1245','Collonge-Bellerive',1),
('1246','Corsier GE',1),
('1247','Anières',1),
('1248','Hermance',1),
('1251','Gy',1),
('1252','Meinier',1),
('1253','Vandoeuvres',1),
('1254','Jussy',1),
('1255','Veyrier',1),
('1256','Troinex',1),
('1257','La Croix-de-Rozon',1),
('1258','Perly',1),
('1281','Russin',1),
('1283','Dardagny',1),
('1283','La Plaine',1),
('1284','Chancy',1),
('1285','Athenaz (Avusy)',1),
('1286','Soral',1),
('1287','Laconnex',1),
('1288','Aire-la-Ville',1),
('1289','Genève Services Spéciaux',1),
('1290','Versoix',1),
('1292','Chambésy',1),
('1293','Bellevue',1),
('1294','Genthod',1),
('1298','Céligny',1),
('8750','Riedern',1),
('8750','Klöntal',1),
('8750','Glarus',1),
('8752','Näfels',1),
('8753','Mollis',1),
('8754','Netstal',1),
('8755','Ennenda',1),
('8756','Mitlödi',1),
('8757','Filzbach',1),
('8758','Obstalden',1),
('8759','Netstal',1),
('8762','Schwanden GL',1),
('8762','Schwändi b. Schwanden',1),
('8762','Sool',1),
('8765','Engi',1),
('8766','Matt',1),
('8767','Elm',1),
('8772','Nidfurn',1),
('8773','Haslen GL',1),
('8774','Leuggelbach',1),
('8775','Luchsingen',1),
('8775','Hätzingen',1),
('8777','Diesbach GL',1),
('8777','Betschwanden',1),
('8782','Rüti GL',1),
('8783','Linthal',1),
('8784','Braunwald',1),
('8865','Bilten',1),
('8866','Ziegelbrücke',1),
('8867','Niederurnen',1),
('8868','Oberurnen',1),
('8874','Mühlehorn',1),
('7077','Valbella',1),
('7078','Lenzerheide/Lai',1),
('7082','Vaz/Obervaz',1),
('7083','Lantsch/Lenz',1),
('7084','Brienz/Brinzauls GR',1),
('7431','Obermutten',1),
('7431','Mutten',1),
('7450','Tiefencastel',1),
('7451','Alvaschein',1),
('7452','Cunter',1),
('7453','Tinizong',1),
('7454','Rona',1),
('7455','Mulegns',1),
('7456','Sur',1),
('7456','Marmorera',1),
('7457','Bivio',1),
('7458','Mon',1),
('7459','Stierva',1),
('7460','Savognin',1),
('7462','Salouf',1),
('7463','Riom',1),
('7464','Parsonz',1),
('7472','Surava',1),
('7473','Alvaneu Bad',1),
('7477','Filisur',1),
('7482','Stugl/Stuls',1),
('7482','Bergün/Bravuogn',1),
('7482','Preda',1),
('7484','Latsch',1),
('7492','Alvaneu Dorf',1),
('7493','Schmitten (Albula)',1),
('7710','Ospizio Bernina',1),
('7710','Alp Grüm',1),
('7741','S. Carlo (Poschiavo)',1),
('7742','Poschiavo',1),
('7742','La Rösa',1),
('7742','Sfazù',1),
('7743','Miralago',1),
('7743','Brusio',1),
('7744','Campocologno',1),
('7745','Li Curt',1),
('7746','Le Prese',1),
('7747','Viano',1),
('7748','Campascio',1),
('7404','Feldis/Veulden',1),
('7405','Rothenbrunnen',1),
('7407','Trans',1),
('7408','Realta',1),
('7408','Cazis',1),
('7411','Sils im Domleschg',1),
('7412','Scharans',1),
('7413','Fürstenaubruck',1),
('7414','Fürstenau',1),
('7415','Pratval',1),
('7415','Rodels',1),
('7416','Almens',1),
('7417','Paspels',1),
('7418','Tumegl/Tomils',1),
('7419','Scheid',1),
('7421','Summaprada',1),
('7422','Tartar',1),
('7423','Sarn',1),
('7423','Portein',1),
('7424','Dalin',1),
('7424','Präz',1),
('7425','Masein',1),
('7426','Flerden',1),
('7427','Urmein',1),
('7428','Glaspass',1),
('7428','Tschappina',1),
('7430','Rongellen',1),
('7430','Thusis',1),
('7432','Zillis',1),
('7433','Mathon',1),
('7433','Wergenstein',1),
('7433','Lohn GR',1),
('7433','Donat',1),
('7433','Farden',1),
('7434','Sufers',1),
('7435','Splügen',1),
('7436','Medels im Rheinwald',1),
('7437','Nufenen',1),
('7438','Hinterrhein',1),
('7440','Andeer',1),
('7442','Clugin',1),
('7443','Pignia',1),
('7444','Ausserferrera',1),
('7445','Innerferrera',1),
('7446','Campsut-Cröt',1),
('7447','Cresta (Avers)',1),
('7447','Am Bach (Avers)',1),
('7448','Juf',1),
('7012','Felsberg',1),
('7013','Domat/Ems',1),
('7014','Trin',1),
('7015','Tamins',1),
('7016','Trin Mulin',1),
('7017','Flims Dorf',1),
('7018','Flims Waldhaus',1),
('7019','Fidaz',1),
('7402','Bonaduz',1),
('7403','Rhäzüns',1),
('7527','Brail',1),
('7530','Zernez',1),
('7532','Tschierv',1),
('7533','Fuldera',1),
('7534','Lü',1),
('7535','Valchava',1),
('7536','Sta. Maria Val Müstair',1),
('7537','Müstair',1),
('7542','Susch',1),
('7543','Lavin',1),
('7545','Guarda',1),
('7546','Ardez',1),
('7550','Scuol',1),
('7551','Ftan',1),
('7552','Vulpera',1),
('7553','Tarasp',1),
('7554','Crusch',1),
('7554','Sent',1),
('7556','Ramosch',1),
('7557','Vnà',1),
('7558','Strada',1),
('7559','Tschlin',1),
('7560','Martina',1),
('7562','Samnaun-Compatsch',1),
('7563','Samnaun Dorf',1),
('7023','Haldenstein',1),
('7201','Untervaz Bahnhof',1),
('7202','Says',1),
('7203','Trimmis',1),
('7204','Untervaz',1),
('7205','Zizers',1),
('7206','Igis',1),
('7208','Malans GR',1),
('7302','Landquart',1),
('7303','Mastrils',1),
('7304','Maienfeld',1),
('7306','Fläsch',1),
('7307','Jenins',1),
('7500','St. Moritz',1),
('7502','Bever',1),
('7503','Samedan',1),
('7504','Pontresina',1),
('7505','Celerina/Schlarigna',1),
('7512','Champfèr',1),
('7513','Silvaplana',1),
('7513','Silvaplana-Surlej',1),
('7514','Sils/Segl Maria',1),
('7514','Fex',1),
('7515','Sils/Segl Baselgia',1),
('7516','Maloja',1),
('7517','Plaun da Lej',1),
('7522','La Punt-Chamues-ch',1),
('7523','Madulain',1),
('7524','Zuoz',1),
('7525','S-chanf',1),
('7526','Cinuos-chel',1),
('7602','Casaccia',1),
('7603','Vicosoprano',1),
('7604','Borgonovo',1),
('7605','Stampa',1),
('7606','Promontogno',1),
('7608','Castasegna',1),
('7610','Soglio',1),
('6534','S. Vittore',1),
('6535','Roveredo GR',1),
('6537','Grono',1),
('6538','Verdabbio',1),
('6538','Verdabbio',1),
('6540','Castaneda',1),
('6541','Sta. Maria in Calanca',1),
('6542','Buseno',1),
('6543','Arvigo',1),
('6544','Braggio',1),
('6545','Selma',1),
('6546','Cauco',1),
('6547','Augio',1),
('6548','Rossa',1),
('6549','Laura',1),
('6556','Leggia',1),
('6557','Cama',1),
('6558','Lostallo',1),
('6562','Soazza',1),
('6563','Mesocco',1),
('6565','S. Bernardino',1),
('7000','Chur',1),
('7001','Chur',1),
('7002','Chur',1),
('7003','Chur Postauto GR Reg. Chur',1),
('7004','Chur',1),
('7006','Chur',1),
('7007','Chur',1),
('7026','Maladers',1),
('7027','Calfreisen',1),
('7027','Castiel',1),
('7027','Lüen',1),
('7028','Pagig',1),
('7028','St. Peter',1),
('7029','Peist',1),
('7050','Arosa',1),
('7056','Molinis',1),
('7057','Langwies',1),
('7058','Litzirüti',1),
('7062','Passugg-Araschgen',1),
('7063','Praden',1),
('7064','Tschiertschen',1),
('7074','Malix',1),
('7075','Churwalden',1),
('7076','Parpan',1),
('7212','Seewis-Schmitten',1),
('7212','Seewis Dorf',1),
('7212','Seewis-Pardisla',1),
('7213','Valzeina',1),
('7214','Grüsch',1),
('7214','Seewis-Schmitten',1),
('7214','Seewis-Pardisla',1),
('7215','Fanas',1),
('7220','Schiers',1),
('7222','Mittellunden',1),
('7223','Buchen im Prättigau',1),
('7224','Putz',1),
('7226','Fajauna',1),
('7226','Stels',1),
('7228','Pusserein',1),
('7228','Schuders',1),
('7231','Pragg-Jenaz',1),
('7232','Furna',1),
('7233','Jenaz',1),
('7235','Fideris',1),
('7240','Küblis',1),
('7241','Conters im Prättigau',1),
('7242','Luzein',1),
('7243','Pany',1),
('7244','Gadenstätt',1),
('7245','Ascharina',1),
('7246','St. Antönien',1),
('7247','Saas im Prättigau',1),
('7249','Serneus',1),
('7250','Klosters',1),
('7252','Klosters Dorf',1),
('7260','Davos Dorf',1),
('7265','Davos Wolfgang',1),
('7270','Davos Platz',1),
('7272','Davos Clavadel',1),
('7276','Davos Frauenkirch',1),
('7277','Davos Glaris',1),
('7278','Davos Monstein',1),
('7494','Davos Wiesen',1),
('7031','Laax GR',1),
('7032','Laax GR 2',1),
('7104','Versam',1),
('7104','Arezen',1),
('7106','Tenna',1),
('7107','Safien Platz',1),
('7109','Thalkirch',1),
('7110','Peiden',1),
('7111','Pitasch',1),
('7112','Duvin',1),
('7113','Camuns',1),
('7114','Uors (Lumnezia)',1),
('7115','Surcasti',1),
('7116','St. Martin (Lugnez)',1),
('7116','Tersnaus',1),
('7122','Carrera',1),
('7122','Valendas',1),
('7126','Castrisch',1),
('7127','Sevgein',1),
('7128','Riein',1),
('7130','Schnaus',1),
('7130','Ilanz',1),
('7132','Vals',1),
('7133','Obersaxen Affeier',1),
('7134','Obersaxen Meierhof',1),
('7135','Obersaxen Giraniga',1),
('7136','Obersaxen Friggahüs',1),
('7137','Flond',1),
('7138','Surcuolm',1),
('7141','Luven',1),
('7142','Cumbel',1),
('7143','Morissen',1),
('7144','Vella',1),
('7145','Degen',1),
('7146','Vattiz',1),
('7147','Vignogn',1),
('7148','Lumbrein',1),
('7148','Surin',1),
('7149','Vrin',1),
('7151','Schluein',1),
('7152','Sagogn',1),
('7153','Falera',1),
('7154','Ruschein',1),
('7155','Ladir',1),
('7156','Pigniu',1),
('7156','Rueun',1),
('7157','Siat',1),
('7158','Waltensburg/Vuorz',1),
('7159','Andiast',1),
('7162','Tavanasa',1),
('7163','Danis',1),
('7164','Dardin',1),
('7165','Breil/Brigels',1),
('7166','Trun',1),
('7167','Zignau',1),
('7168','Schlans',1),
('7172','Rabius',1),
('7173','Surrein',1),
('7174','S. Benedetg',1),
('7175','Sumvitg',1),
('7176','Cumpadials',1),
('7180','Disentis/Mustér',1),
('7182','Cavardiras',1),
('7183','Mumpé Medel',1),
('7184','Curaglia',1),
('7185','Platta',1),
('7186','Segnas',1),
('7187','Camischolas',1),
('7188','Sedrun',1),
('7189','Rueras',1),
('2800','Delémont',1),
('2802','Develier',1),
('2803','Bourrignon',1),
('2805','Soyhières',1),
('2806','Mettembert',1),
('2807','Pleigne',1),
('2807','Lucelle',1),
('2812','Movelier',1),
('2813','Ederswiler',1),
('2822','Courroux',1),
('2823','Courcelon',1),
('2824','Vicques',1),
('2825','Courchapoix',1),
('2826','Corban',1),
('2827','Mervelier',1),
('2828','Montsevelier',1),
('2829','Vermes',1),
('2830','Vellerat',1),
('2830','Courrendlin',1),
('2832','Rebeuvelier',1),
('2842','Rossemaison',1),
('2843','Châtillon JU',1),
('2852','Courtételle',1),
('2853','Courfaivre',1),
('2854','Bassecourt',1),
('2855','Glovelier',1),
('2856','Boécourt',1),
('2857','Montavon',1),
('2863','Undervelier',1),
('2864','Soulce',1),
('2873','Saulcy',1),
('2336','Les Bois',1),
('2338','Les Emibois',1),
('2338','Muriaux',1),
('2340','Le Noirmont',1),
('2345','La Chaux-des-Breuleux',1),
('2345','Le Cerneux-Veusil',1),
('2345','Les Breuleux',1),
('2350','Saignelégier',1),
('2353','Les Pommerats',1),
('2354','Goumois',1),
('2360','Le Bémont JU',1),
('2362','Montfavergier',1),
('2362','Montfaucon',1),
('2363','Les Enfers',1),
('2364','St-Brais',1),
('2714','Les Genevez JU',1),
('2714','Le Prédame',1),
('2718','Lajoux JU',1),
('2718','Fornet-Dessus',1),
('2887','Soubey',1),
('2882','St-Ursanne',1),
('2883','Montmelon',1),
('2884','Montenol',1),
('2885','Epauvillers',1),
('2886','Epiquerez',1),
('2888','Seleute',1),
('2889','Ocourt',1),
('2900','Porrentruy',1),
('2902','Fontenais',1),
('2903','Villars-sur-Fontenais',1),
('2904','Bressaucourt',1),
('2905','Courtedoux',1),
('2906','Chevenez',1),
('2907','Rocourt',1),
('2908','Grandfontaine',1),
('2912','Réclère',1),
('2912','Roche-d''Or',1),
('2914','Damvant',1),
('2915','Bure',1),
('2916','Fahy',1),
('2922','Courchavon',1),
('2923','Courtemaîche',1),
('2924','Montignez',1),
('2925','Buix',1),
('2926','Boncourt',1),
('2932','Coeuve',1),
('2933','Lugnez',1),
('2933','Damphreux',1),
('2935','Beurnevésin',1),
('2942','Alle',1),
('2943','Vendlincourt',1),
('2944','Bonfol',1),
('2946','Miécourt',1),
('2947','Charmoille',1),
('2950','Courtemautruy',1),
('2950','Courgenay',1),
('2952','Cornol',1),
('2953','Pleujouse',1),
('2953','Fregiécourt',1),
('2954','Asuel',1),
('6105','Schachen LU',1),
('6106','Werthenstein',1),
('6112','Doppleschwand',1),
('6113','Romoos',1),
('6160','Entlebuch Businesszentrum',1),
('6161','Entlebuch Versandzentrum',1),
('6162','Rengg',1),
('6162','Entlebuch',1),
('6162','Finsterwald b. Entlebuch',1),
('6163','Ebnet',1),
('6166','Hasle LU',1);

use marketdb;
insert into dbo.cities (zip_code, city_name,country_id)
values ('6167','Bramboden',1),
('6170','Schüpfheim',1),
('6173','Flühli LU',1),
('6174','Sörenberg',1),
('6182','Escholzmatt',1),
('6192','Wiggen',1),
('6196','Marbach LU',1),
('6020','Emmenbrücke',1),
('6021','Emmenbrücke 1',1),
('6023','Rothenburg',1),
('6026','Rain',1),
('6027','Römerswil LU',1),
('6028','Herlisberg',1),
('6032','Emmen',1),
('6034','Inwil',1),
('6274','Eschenbach LU',1),
('6275','Ballwil',1),
('6276','Hohenrain',1),
('6277','Kleinwangen',1),
('6277','Lieli LU',1),
('6280','Hochdorf',1),
('6280','Urswil',1),
('6281','Hochdorf',1),
('6283','Baldegg',1),
('6284','Sulz LU',1),
('6284','Gelfingen',1),
('6285','Hitzkirch',1),
('6285','Retschwil',1),
('6286','Altwis',1),
('6287','Aesch LU',1),
('6288','Schongau',1),
('6289','Müswangen',1),
('6289','Hämikon',1),
('6294','Ermensee',1),
('6295','Mosen',1),
('6000','Luzern 1 PF',1),
('6000','Luzern 14',1),
('6000','Luzern Kaserne',1),
('6000','Luzern 31',1),
('6000','Luzern 15',1),
('6000','Luzern 16',1),
('6000','Luzern 4',1),
('6000','Luzern',1),
('6000','Luzern 7',1),
('6000','Luzern 30 AAL',1),
('6000','Luzern 6',1),
('6000','Luzern 2 Universität',1),
('6000','Luzern 11',1),
('6000','Luzern 10',1),
('6000','Luzern 1 Annahme',1),
('6000','Luzern Bahnhof SBB',1),
('6000','Luzern Altstadt',1),
('6000','Luzern Zustellung',1),
('6000','Luzern Postauto Zentralschw',1),
('6002','Luzern',1),
('6002','Luzern Uni PG',1),
('6003','Luzern',1),
('6004','Luzern',1),
('6005','Luzern',1),
('6005','St. Niklausen LU',1),
('6006','Luzern',1),
('6007','Luzern',1),
('6008','Luzern UBS',1),
('6009','Luzern',1),
('6010','Kriens',1),
('6010','Kriens',1),
('6011','Kriens',1),
('6012','Obernau',1),
('6013','Eigenthal',1),
('6014','Luzern',1),
('6015','Luzern',1),
('6030','Ebikon',1),
('6031','Ebikon',1),
('6033','Buchrain',1),
('6035','Perlen',1),
('6036','Dierikon',1),
('6037','Root',1),
('6038','Honau',1),
('6038','Gisikon',1),
('6039','Root Längenbold',1),
('6043','Adligenswil',1),
('6044','Udligenswil',1),
('6045','Meggen',1),
('6047','Kastanienbaum',1),
('6048','Horw',1),
('6102','Malters',1),
('6103','Schwarzenberg LU',1),
('6344','Meierskappel',1),
('6353','Weggis',1),
('6354','Vitznau',1),
('6356','Rigi Kaltbad',1),
('6404','Greppen',1),
('5735','Pfeffikon LU',1),
('6016','Hellbühl',1),
('6017','Ruswil',1),
('6018','Buttisholz',1),
('6019','Sigigen',1),
('6022','Grosswangen',1),
('6024','Hildisrieden',1),
('6025','Neudorf',1),
('6110','Fontannen b. Wolhusen',1),
('6110','Wolhusen',1),
('6114','Steinhuserberg',1),
('6203','Sempach Station',1),
('6204','Sempach',1),
('6205','Eich',1),
('6206','Neuenkirch',1),
('6207','Nottwil',1),
('6208','Oberkirch LU',1),
('6210','Sursee',1),
('6212','St. Erhard',1),
('6212','Kaltbach',1),
('6213','Knutwil',1),
('6214','Schenkon',1),
('6215','Schwarzenbach LU',1),
('6215','Beromünster',1),
('6216','Mauensee',1),
('6221','Rickenbach LU',1),
('6222','Gunzwil',1),
('6231','Schlierbach',1),
('6232','Geuensee',1),
('6233','Büron',1),
('6234','Triengen',1),
('6234','Kulmerau',1),
('6235','Winikon',1),
('6236','Wilihof',1),
('4806','Wikon',1),
('4915','St. Urban',1),
('6122','Menznau',1),
('6123','Geiss',1),
('6125','Menzberg',1),
('6126','Daiwil',1),
('6130','Willisau',1),
('6132','Rohrmatt',1),
('6133','Hergiswil b. Willisau',1),
('6142','Gettnau',1),
('6143','Ohmstal',1),
('6144','Zell LU',1),
('6145','Fischbach LU',1),
('6146','Grossdietwil',1),
('6147','Altbüron',1),
('6152','Hüswil',1),
('6153','Ufhusen',1),
('6154','Hofstatt',1),
('6156','Luthern',1),
('6156','Luthern Bad',1),
('6211','Buchs LU',1),
('6217','Kottwil',1),
('6218','Ettiswil',1),
('6242','Wauwil',1),
('6243','Egolzwil',1),
('6244','Nebikon',1),
('6245','Ebersecken',1),
('6246','Altishofen',1),
('6247','Schötz',1),
('6248','Alberswil',1),
('6252','Dagmersellen',1),
('6253','Uffikon',1),
('6260','Hintermoos',1),
('6260','Reidermoos',1),
('6260','Reiden',1),
('6260','Mehlsecken',1),
('6262','Langnau b. Reiden',1),
('6263','Richenthal',1),
('6264','Pfaffnau',1),
('6265','Roggliswil',1),
('2012','Auvernier',1),
('2013','Colombier NE',1),
('2014','Bôle',1),
('2015','Areuse',1),
('2016','Cortaillod',1),
('2017','Boudry',1),
('2019','Chambrelien',1),
('2019','Rochefort',1),
('2022','Bevaix',1),
('2023','Gorgier',1),
('2024','St-Aubin-Sauges',1),
('2025','Chez-le-Bart',1),
('2027','Fresens',1),
('2027','Montalchez',1),
('2028','Vaumarcus',1),
('2034','Peseux',1),
('2035','Corcelles NE',1),
('2036','Cormondrèche',1),
('2037','Montezillon',1),
('2149','Fretereules',1),
('2149','Champ-du-Moulin',1),
('2149','Brot-Dessous',1),
('2300','La Chaux-de-Fonds',1),
('2300','La Cibourg',1),
('2301','La Chx-de-F. Combe-à-l''Ours',1),
('2301','La Chaux-de-Fonds',1),
('2302','La Chaux-de-Fonds',1),
('2303','La Chaux-de-Fonds',1),
('2304','La Chaux-de-Fonds',1),
('2306','La Chaux-de-Fonds',1),
('2314','La Sagne NE',1),
('2322','Le Crêt-du-Locle',1),
('2325','Les Planchettes',1),
('2316','Les Ponts-de-Martel',1),
('2316','Petit-Martel',1),
('2318','Brot-Plamboz',1),
('2400','Le Prévoux',1),
('2400','Le Locle',1),
('2405','La Chaux-du-Milieu',1),
('2406','La Châtagne',1),
('2406','La Brévine',1),
('2406','Le Brouillet',1),
('2406','Les Taillères',1),
('2414','Le Cerneux-Péquignot',1),
('2416','Les Brenets',1),
('2000','Neuchâtel',1),
('2001','Neuchâtel 1 Dépôt',1),
('2001','Neuchâtel 1',1),
('2002','Neuchâtel 2',1),
('2003','Neuchâtel 3',1),
('2004','Neuchâtel 4',1),
('2006','Neuchâtel 6',1),
('2007','Neuchâtel 7',1),
('2008','Neuchâtel',1),
('2009','Neuchâtel 9',1),
('2010','Neuchâtel OFS',1),
('2067','Chaumont',1),
('2068','Hauterive NE',1),
('2072','St-Blaise',1),
('2073','Enges',1),
('2074','Marin-Epagnier',1),
('2075','Thielle',1),
('2075','Wavre',1),
('2087','Cornaux NE',1),
('2088','Cressier NE',1),
('2523','Lignières',1),
('2525','Le Landeron',1),
('2037','Montmollin',1),
('2042','Valangin',1),
('2043','Boudevilliers',1),
('2046','Fontaines NE',1),
('2052','La Vue-des-Alpes',1),
('2052','Fontainemelon',1),
('2053','Cernier',1),
('2054','Chézard-St-Martin',1),
('2054','Les Vieux-Prés',1),
('2056','Dombresson',1),
('2057','Villiers',1),
('2058','Le Pâquier NE',1),
('2063','Saules',1),
('2063','Fenin',1),
('2063','Engollon',1),
('2063','Vilars NE',1),
('2065','Savagnier',1),
('2206','Les Geneveys-sur-Coffrane',1),
('2207','Coffrane',1),
('2208','Les Hauts-Geneveys',1),
('2103','Noiraigue',1),
('2105','Travers',1),
('2108','Couvet',1),
('2112','Môtiers NE',1),
('2113','Boveresse',1),
('2114','Fleurier',1),
('2115','Buttes',1),
('2116','Mont-de-Buttes',1),
('2117','La Côte-aux-Fées',1),
('2123','St-Sulpice NE',1),
('2124','Les Sagnettes',1),
('2126','Les Verrières',1),
('2127','Les Bayards',1),
('6052','Hergiswil NW',1),
('6362','Stansstad',1),
('6363','Fürigen',1),
('6363','Bürgenstock',1),
('6363','Obbürgen',1),
('6365','Kehrsiten',1),
('6370','Oberdorf NW',1),
('6370','Stans',1),
('6371','Stans',1),
('6372','Ennetmoos',1),
('6373','Ennetbürgen',1),
('6374','Buochs',1),
('6375','Beckenried',1),
('6376','Emmetten',1),
('6382','Büren NW',1),
('6383','Niederrickenbach',1),
('6383','Wirzweli',1),
('6383','Dallenwil',1),
('6383','Niederrickenbach',1),
('6383','Wiesenberg',1),
('6386','Wolfenschiessen',1),
('6387','Oberrickenbach',1),
('6053','Alpnachstad',1),
('6055','Alpnach Dorf',1),
('6056','Kägiswil',1),
('6060','Ramersberg',1),
('6060','Sarnen',1),
('6061','Sarnen 1',1),
('6062','Wilen (Sarnen)',1),
('6063','Stalden (Sarnen)',1),
('6064','Kerns',1),
('6066','St. Niklausen OW',1),
('6067','Melchtal',1),
('6068','Melchsee-Frutt',1),
('6072','Sachseln',1),
('6073','Flüeli-Ranft',1),
('6074','Giswil',1),
('6078','Lungern',1),
('6078','Bürglen OW',1),
('6388','Grafenort',1),
('6390','Engelberg',1),
('6391','Engelberg',1),
('9000','St. Gallen',1),
('9001','St. Gallen Postauto SG-Azel',1),
('9001','St. Gallen',1),
('9004','St. Gallen',1),
('9006','St. Gallen',1),
('9007','St. Gallen',1),
('9008','St. Gallen',1),
('9009','St. Gallen',1),
('9010','St. Gallen',1),
('9011','St. Gallen',1),
('9012','St. Gallen',1),
('9013','St. Gallen',1),
('9014','St. Gallen',1),
('9015','St. Gallen',1),
('9016','St. Gallen',1),
('9020','St. Gallen',1),
('9020','St. Gallen KC PKGK 5',1),
('9022','St. Gallen',1),
('9023','St. Gallen',1),
('9024','St. Gallen Presse-Serv.Güll',1),
('9025','St. Gallen Quelle',1),
('9026','St. Gallen Künzler AG',1),
('9027','St. Gallen Mona Versand',1),
('9028','St. Gallen',1),
('9029','St. Gallen Sonderdienste',1),
('9030','Abtwil SG',1),
('9030','St. Josefen',1),
('9032','Engelburg',1),
('9034','Eggersriet',1),
('9036','Grub SG',1),
('9200','Gossau SG',1),
('9201','Gossau SG',1),
('9204','Andwil SG',1),
('9205','Waldkirch',1),
('9212','Arnegg',1),
('9300','Wittenbach',1),
('9301','Wittenbach',1),
('9304','Bernhardzell',1),
('9308','Lömmenschwil',1),
('9312','Häggenschwil',1),
('9313','Muolen',1),
('9033','Untereggen',1),
('9305','Berg SG',1),
('9323','Steinach',1),
('9327','Tübach',1),
('9400','Rorschach',1),
('9401','Rorschach',1),
('9402','Mörschwil',1),
('9403','Goldach',1),
('9404','Rorschacherberg',1),
('9422','Staad SG',1),
('9423','Altenrhein',1),
('9425','Thal',1),
('9424','Rheineck',1),
('9430','St. Margrethen SG',1),
('9434','Au SG',1),
('9435','Heerbrugg',1),
('9436','Balgach',1),
('9437','Marbach SG',1),
('9442','Berneck',1),
('9443','Widnau',1),
('9444','Diepoldsau',1),
('9445','Rebstein',1),
('9450','Lüchingen',1),
('9450','Altstätten SG',1),
('9451','Kriessern',1),
('9452','Hinterforst',1),
('9453','Eichberg',1),
('9462','Montlingen',1),
('9463','Oberriet SG',1),
('9464','Lienz',1),
('9464','Rüthi (Rheintal)',1),
('9465','Salez',1),
('9466','Sennwald',1),
('9467','Frümsen',1),
('9468','Sax',1),
('9469','Haag (Rheintal)',1),
('9470','Buchs SG',1),
('9470','Werdenberg',1),
('9471','Buchs Bahnhof SBB',1),
('9471','Buchs SG 1',1),
('9471','Buchs SG 3',1),
('9472','Grabs',1),
('9472','Grabserberg',1),
('9473','Gams',1),
('9475','Sevelen',1),
('9476','Fontnas',1),
('9476','Weite',1),
('9477','Trübbach',1),
('9478','Azmoos',1),
('9479','Oberschan',1),
('9479','Malans SG',1),
('9479','Gretschins',1),
('7310','Bad Ragaz',1),
('7312','Pfäfers',1),
('7313','St. Margrethenberg',1),
('7314','Vadura',1),
('7315','Vättis',1),
('7317','Valens',1),
('7317','Vasön',1),
('7320','Sargans',1),
('7323','Wangs',1),
('7324','Vilters',1),
('7325','Schwendi im Weisstannental',1),
('7326','Weisstannen',1),
('8877','Murg',1),
('8878','Quinten',1),
('8879','Pizolpark (Mels)',1),
('8880','Walenstadt',1),
('8881','Knoblisbühl',1),
('8881','Tscherlach',1),
('8881','Walenstadtberg',1),
('8882','Unterterzen',1),
('8883','Quarten',1),
('8884','Oberterzen',1),
('8885','Mols',1),
('8886','Mädris-Vermol',1),
('8887','Mels',1),
('8888','Heiligkreuz (Mels)',1),
('8889','Plons',1),
('8890','Flums',1),
('8892','Berschis',1),
('8893','Flums Hochwiese',1),
('8894','Flumserberg Saxli',1),
('8895','Flumserberg Portels',1),
('8896','Flumserberg Bergheim',1),
('8897','Flumserberg Tannenheim',1),
('8898','Flumserberg Tannenbodenalp',1),
('8638','Goldingen',1),
('8640','Rapperswil SG',1),
('8645','Jona',1),
('8646','Wagen',1),
('8715','Bollingen',1),
('8716','Schmerikon',1),
('8717','Benken SG',1),
('8718','Schänis',1),
('8722','Kaltbrunn',1),
('8723','Maseltrangen',1),
('8723','Rufi',1),
('8725','Ernetschwil',1),
('8725','Gebertingen',1),
('8726','Ricken SG',1),
('8727','Walde SG',1),
('8730','Uznach',1),
('8732','Neuhaus SG',1),
('8733','Eschenbach SG',1),
('8734','Ermenswil',1),
('8735','Rüeterswil',1),
('8735','St. Gallenkappel',1),
('8737','Gommiswald',1),
('8738','Uetliburg SG',1),
('8739','Rieden SG',1),
('8740','Uznach Vögele Versandhaus',1),
('8872','Weesen',1),
('8873','Amden',1),
('9114','Hoffeld',1),
('9115','Dicken',1),
('9122','Ebersol',1),
('9122','Mogelsberg',1),
('9123','Nassen',1),
('9125','Brunnadern',1),
('9126','Necker',1),
('9127','St. Peterzell',1),
('9533','Dietschwil',1),
('9533','Kirchberg SG',1),
('9534','Gähwil',1),
('9601','Lütisburg Station',1),
('9602','Bazenheid',1),
('9602','Müselbach',1),
('9604','Oberrindal',1),
('9604','Lütisburg',1),
('9604','Unterrindal',1),
('9606','Bütschwil',1),
('9607','Mosnang',1),
('9608','Ganterschwil',1),
('9612','Dreien',1),
('9613','Mühlrüti',1),
('9614','Libingen',1),
('9615','Dietfurt',1),
('9620','Lichtensteig',1),
('9621','Oberhelfenschwil',1),
('9622','Krinau',1),
('9630','Wattwil',1),
('9631','Ulisbach',1),
('9633','Bächli (Hemberg)',1),
('9633','Hemberg',1),
('9642','Ebnat-Kappel',1),
('9643','Krummenau',1),
('9650','Nesslau',1),
('9651','Ennetbühl',1),
('9652','Neu St. Johann',1),
('9655','Stein SG',1),
('9656','Alt St. Johann',1),
('9657','Unterwasser',1),
('9658','Wildhaus',1),
('9113','Degersheim',1),
('9116','Wolfertswil',1),
('9203','Niederwil SG',1),
('9230','Flawil',1),
('9231','Egg (Flawil)',1),
('9240','Niederglatt SG',1),
('9240','Uzwil',1),
('9242','Oberuzwil',1),
('9243','Jonschwil',1),
('9244','Niederuzwil',1),
('9245','Sonnental',1),
('9245','Oberbüren',1),
('9246','Niederbüren',1),
('9247','Henau',1),
('9248','Bichwil',1),
('9249','Algetshausen',1),
('9249','Oberstetten',1),
('9249','Niederstetten',1),
('9500','Wil SG',1),
('9501','Wil SG 1',1),
('9510','Wil SG Distributionsbasis',1),
('9512','Rossrüti',1),
('9523','Züberwangen',1),
('9524','Zuzwil SG',1),
('9525','Lenggenwil',1),
('9526','Zuckenriet',1),
('9527','Niederhelfenschwil',1),
('9536','Schwarzenbach SG',1),
('9552','Bronschhofen',1),
('8213','Neunkirch',1),
('8214','Gächlingen',1),
('8223','Guntmadingen',1),
('8224','Löhningen',1),
('8234','Stetten SH',1),
('8235','Lohn SH',1),
('8236','Büttenhardt',1),
('8236','Opfertshofen SH',1),
('8239','Dörflingen',1),
('8240','Thayngen',1),
('8241','Barzheim',1),
('8242','Hofen SH',1),
('8242','Bibern SH',1),
('8243','Altdorf SH',1),
('8200','Schaffhausen',1),
('8201','Schaffhausen',1),
('8202','Schaffhausen',1),
('8203','Schaffhausen',1),
('8204','Schaffhausen',1),
('8205','Schaffhausen',1),
('8207','Schaffhausen',1),
('8208','Schaffhausen',1),
('8210','Schaffhausen Dist Ba',1),
('8212','Neuhausen am Rheinfall',1),
('8222','Beringen',1),
('8231','Hemmental',1),
('8232','Merishausen',1),
('8233','Bargen SH',1),
('8454','Buchberg',1),
('8455','Buchberg',1),
('8455','Rüdlingen',1),
('8455','Buchberg',1),
('8225','Siblingen',1),
('8226','Schleitheim',1),
('8228','Beggingen',1),
('8260','Stein am Rhein',1),
('8261','Hemishofen',1),
('8262','Ramsen',1),
('8263','Buch SH',1),
('8215','Hallau',1),
('8216','Oberhallau',1),
('8217','Wilchingen',1),
('8218','Osterfingen',1),
('8219','Trasadingen',1),
('4611','Härkingen Scanning-Center',1),
('4620','Härkingen Paketzentrum',1),
('4620','Härkingen Dist Ba',1),
('4621','Härkingen Briefzentrum',1),
('4621','Härkingen SPS AG',1),
('4621','Härkingen SPS DO',1),
('4621','Härkingen BZ FP',1),
('4621','Härkingen BZ Briefklinik',1),
('4622','Egerkingen',1),
('4623','Neuendorf',1),
('4624','Härkingen',1),
('4625','Oberbuchsiten',1),
('4626','Niederbuchsiten',1),
('4628','Wolfwil',1),
('4630','Härkingen CALL',1),
('4640','Härkingen ST PP 1',1),
('4702','Oensingen',1),
('4703','Kestenholz',1),
('4710','Balsthal',1),
('4712','Laupersdorf',1),
('4713','Matzendorf',1),
('4714','Aedermannsdorf',1),
('4715','Herbetswil',1),
('4716','Gänsbrunnen',1),
('4716','Welschenrohr',1),
('4717','Mümliswil',1),
('4718','Holderbank SO',1),
('4719','Ramiswil',1),
('3253','Schnottwil',1),
('3254','Balm b. Messen',1),
('3254','Messen',1),
('3307','Brunnenthal',1),
('4571','Lüterkofen',1),
('4571','Ichertswil',1),
('4574','Lüsslingen',1),
('4574','Nennigkofen',1),
('4576','Tscheppach',1),
('4577','Hessigkofen',1),
('4578','Bibern SO',1),
('4579','Gossliwil',1),
('4581','Küttigkofen',1),
('4582','Brügglen',1),
('4583','Mühledorf SO',1),
('4583','Aetigkofen',1),
('4584','Lüterswil',1),
('4584','Gächliwil',1),
('4585','Biezwil',1),
('4586','Kyburg-Buchegg',1),
('4587','Aetingen',1),
('4588','Unterramsern',1),
('4588','Brittern',1),
('4588','Oberramsern',1),
('4108','Witterswil',1),
('4112','Bättwil',1),
('4112','Flüh',1),
('4114','Hofstetten SO',1),
('4115','Mariastein',1),
('4116','Metzerlen',1),
('4118','Rodersdorf',1),
('4143','Dornach',1),
('4145','Gempen',1),
('4146','Hochwald',1),
('4206','Seewen SO',1),
('4412','Nuglar',1),
('4413','Büren SO',1),
('4421','St. Pantaleon',1),
('4468','Kienberg',1),
('4632','Trimbach',1),
('4633','Hauenstein',1),
('4634','Wisen SO',1),
('4652','Winznau',1),
('4653','Obergösgen',1),
('4654','Lostorf',1),
('4655','Rohr b. Olten',1),
('4655','Stüsslingen',1),
('5013','Niedergösgen',1),
('5015','Erlinsbach SO',1),
('4528','Zuchwil',1),
('4542','Luterbach',1),
('4543','Deitingen',1),
('4551','Derendingen Swisscom',1),
('4552','Derendingen',1),
('4553','Subingen',1),
('4554','Hüniken',1),
('4554','Etziken',1),
('4556','Bolken',1),
('4556','Burgäschi',1),
('4556','Aeschi SO',1),
('4556','Steinhof SO',1),
('4557','Horriwil',1),
('4558','Hersiwil',1),
('4558','Winistorf',1),
('4558','Heinrichswil',1),
('4562','Biberist',1),
('4563','Gerlafingen',1),
('4564','Obergerlafingen',1),
('4565','Recherswil',1),
('4566','Halten',1),
('4566','Oekingen',1),
('4566','Kriegstetten',1),
('4573','Lohn-Ammannsegg',1),
('2540','Grenchen',1),
('2544','Bettlach',1),
('2545','Selzach',1),
('4512','Bellach',1),
('4513','Langendorf',1),
('4514','Lommiswil',1),
('4515','Weissenstein b. Solothurn',1),
('4515','Oberdorf SO',1),
('4522','Rüttenen',1),
('4523','Niederwil SO',1),
('4524','Balmberg',1),
('4524','Günsberg',1),
('4524','Oberbalmberg',1),
('4525','Balm b. Günsberg',1),
('4532','Feldbrunnen',1),
('4533','Riedholz',1),
('4534','Flumenthal',1),
('4535','Kammersrohr',1),
('4535','Hubersdorf',1),
('4600','Olten',1),
('4601','Olten 1 Fächer',1),
('4603','Olten',1),
('4609','Olten Sonderdienste',1),
('4612','Wangen b. Olten',1),
('4613','Rickenbach SO',1),
('4614','Hägendorf',1),
('4614','Hägendorf',1),
('4615','Allerheiligenberg',1),
('4616','Kappel SO',1),
('4617','Gunzgen',1),
('4618','Boningen',1),
('4629','Fulenbach',1),
('4656','Starrkirch-Wil',1),
('4657','Dulliken',1),
('4658','Däniken SO',1),
('5010','Däniken Postzentrum',1),
('5012','Eppenberg',1),
('5012','Schönenwerd',1),
('5012','Wöschnau',1),
('5014','Gretzenbach',1),
('5746','Walterswil SO',1),
('4500','Solothurn',1),
('4501','Solothurn 1 Annahme',1),
('4501','Solothurn',1),
('4502','Solothurn',1),
('4503','Solothurn',1),
('4509','Solothurn',1),
('4204','Himmelried',1),
('4208','Nunningen',1),
('4226','Breitenbach',1),
('4227','Büsserach',1),
('4228','Erschwil',1),
('4229','Beinwil SO',1),
('4232','Fehren',1),
('4233','Meltingen',1),
('4234','Zullwil',1),
('4245','Kleinlützel',1),
('4247','Grindel',1),
('4252','Bärschwil',1),
('8836','Bennau',1),
('8840','Trachslau',1),
('8840','Einsiedeln',1),
('8841','Gross',1),
('8844','Euthal',1),
('8846','Willerzell',1),
('8847','Egg SZ',1),
('6442','Gersau',1),
('8640','Hurden',1),
('8806','Bäch SZ',1),
('8807','Freienbach',1),
('8808','Pfäffikon SZ',1),
('8832','Wollerau',1),
('8832','Wollerau',1),
('8832','Wilen b. Wollerau',1),
('8834','Schindellegi',1),
('8835','Feusisberg',1),
('6402','Merlischachen',1),
('6403','Küssnacht am Rigi',1),
('6405','Immensee',1),
('8852','Altendorf',1),
('8853','Lachen SZ',1),
('8854','Siebnen',1),
('8854','Galgenen',1),
('8855','Wangen SZ',1),
('8856','Tuggen',1),
('8857','Vorderthal',1),
('8858','Innerthal',1),
('8862','Schübelbach',1),
('8863','Buttikon SZ',1),
('8864','Reichenburg',1),
('6410','Rigi Scheidegg',1),
('6410','Goldau',1),
('6410','Rigi Staffel',1),
('6410','Rigi Klösterli',1),
('6410','Rigi Kulm',1),
('6414','Oberarth',1),
('6415','Arth',1),
('6416','Steinerberg',1),
('6417','Sattel',1),
('6418','Rothenthurm',1),
('6422','Steinen',1),
('6423','Seewen SZ',1),
('6424','Lauerz',1),
('6430','Schwyz',1),
('6431','Schwyz',1),
('6432','Rickenbach b. Schwyz',1),
('6433','Stoos SZ',1),
('6434','Illgau',1),
('6436','Muotathal',1),
('6436','Bisisthal',1),
('6436','Ried (Muotathal)',1),
('6438','Ibach',1),
('6440','Brunnen',1),
('6443','Morschach',1),
('6452','Riemenstalden',1),
('8842','Unteriberg',1),
('8843','Oberiberg',1),
('8845','Studen SZ',1),
('8849','Alpthal',1),
('8580','Hagenwil b. Amriswil',1),
('8580','Amriswil',1),
('8580','Sommeri',1),
('8580','Hefenhofen',1),
('8581','Schocherswil',1),
('8582','Dozwil',1),
('8587','Oberaach',1),
('8590','Romanshorn',1),
('8592','Uttwil',1),
('8593','Kesswil',1),
('8599','Salmsach',1),
('9306','Freidorf TG',1),
('9314','Steinebrunn',1),
('9315','Winden',1),
('9315','Neukirch (Egnach)',1),
('9320','Arbon',1),
('9320','Stachen',1),
('9320','Frasnacht',1),
('9322','Egnach',1),
('9325','Roggwil TG',1),
('9326','Horn',1),
('8252','Schlatt TG',1),
('8253','Diessenhofen',1),
('8253','Willisdorf',1),
('8254','Basadingen',1),
('8255','Schlattingen',1),
('8259','Etzwilen',1),
('8259','Wagenhausen',1),
('8259','Kaltenbach',1),
('8259','Rheinklingen',1),
('8264','Eschenz',1),
('8265','Mammern',1),
('8266','Steckborn',1),
('8267','Berlingen',1),
('8500','Gerlikon',1),
('8500','Frauenfeld',1),
('8501','Frauenfeld',1),
('8502','Frauenfeld',1),
('8503','Frauenfeld',1),
('8505','Dettighofen',1),
('8505','Pfyn',1),
('8506','Lanzenneunforn',1),
('8507','Hörhausen',1),
('8508','Homburg',1),
('8510','Frauenfeld Kant. Verwaltung',1),
('8512','Lustdorf',1),
('8512','Wetzikon TG',1),
('8512','Thundorf',1),
('8520','Frauenfeld Dist Ba',1),
('8520','Frauenfeld Paketzentrum',1),
('8524','Buch b. Frauenfeld',1),
('8524','Uesslingen',1),
('8525','Wilen b. Neunforn',1),
('8525','Niederneunforn',1),
('8526','Oberneunforn',1),
('8530','Frauenfeld CALL',1),
('8532','Weiningen TG',1),
('8532','Warth',1),
('8535','Herdern',1),
('8536','Hüttwilen',1),
('8537','Uerschhausen',1),
('8537','Nussbaumen TG',1),
('8540','Frauenfeld ST PP 1',1),
('8546','Kefikon TG',1),
('8546','Islikon',1),
('8547','Gachnang',1),
('8552','Felben-Wellhausen',1),
('8553','Eschikofen',1),
('8553','Harenwilen',1),
('8553','Mettendorf TG',1),
('8553','Hüttlingen',1),
('8555','Müllheim Dorf',1),
('9507','Stettfurt',1),
('9548','Matzingen',1),
('8268','Salenstein',1),
('8268','Mannenbach-Salenstein',1),
('8269','Fruthwilen',1),
('8272','Ermatingen',1),
('8273','Triboltingen',1),
('8274','Gottlieben',1),
('8274','Tägerwilen',1),
('8280','Kreuzlingen',1),
('8285','Kreuzlingen Ifolor AG',1),
('8558','Raperswilen',1),
('8564','Wäldi',1),
('8564','Sonterswil',1),
('8564','Gunterswilen',1),
('8564','Hefenhausen',1),
('8564','Engwilen',1),
('8564','Lipperswil',1),
('8564','Hattenhausen',1),
('8565','Hugelshofen',1),
('8566','Neuwilen',1),
('8566','Ellighausen',1),
('8566','Lippoldswilen',1),
('8566','Dotnacht',1),
('8573','Altishausen',1),
('8573','Alterswilen',1),
('8573','Siegershausen',1),
('8574','Lengwil',1),
('8574','Illighausen',1),
('8574','Dettighofen (Lengwil)',1),
('8574','Oberhofen TG',1),
('8585','Langrickenbach',1),
('8585','Herrenhof',1),
('8585','Zuben',1),
('8585','Schönenbaumgarten',1),
('8594','Güttingen',1),
('8595','Altnau',1),
('8596','Scherzingen',1),
('8596','Münsterlingen',1),
('8597','Landschlacht',1),
('8598','Bottighofen',1),
('8355','Aadorf',1),
('8356','Ettenhausen TG',1),
('8357','Guntershausen b. Aadorf',1),
('8360','Eschlikon TG',1),
('8360','Wallenwil',1),
('8362','Balterswil',1),
('8363','Bichelsee',1),
('8370','Sirnach',1),
('8371','Busswil TG',1),
('8372','Wiezikon b. Sirnach',1),
('8374','Oberwangen TG',1),
('8374','Dussnang',1),
('8376','Au TG',1),
('8376','Fischingen',1),
('8522','Aawangen',1),
('8522','Häuslenen',1),
('9502','Braunau',1),
('9506','Lommis',1),
('9508','Weingarten-Kalthäusern',1),
('9532','Rickenbach b. Wil',1),
('9535','Wilen b. Wil',1),
('9542','Münchwilen TG',1),
('9543','St. Margarethen TG',1),
('9545','Wängi',1),
('9546','Tuttwil',1),
('9547','Wittenwil',1),
('9553','Bettwiesen',1),
('9554','Tägerschen',1),
('9555','Tobel',1),
('9573','Littenheid',1),
('8514','Amlikon-Bissegg',1),
('8554','Müllheim-Wigoltingen',1),
('8554','Bonau',1),
('8556','Wigoltingen',1),
('8556','Engwang',1),
('8556','Lamperswil TG',1),
('8556','Illhart',1),
('8560','Märstetten',1),
('8561','Ottoberg',1),
('8564','Wagerswil',1),
('8570','Weinfelden',1),
('8572','Graltshausen',1),
('8572','Berg TG',1),
('8572','Andhausen',1),
('8572','Guntershausen b. Berg',1),
('8575','Bürglen TG',1),
('8575','Istighofen',1),
('8576','Mauren TG',1),
('8577','Schönholzerswilen',1),
('8583','Sulgen',1),
('8583','Donzhausen',1),
('8583','Götighofen',1),
('8584','Opfershofen TG',1),
('8584','Leimbach TG',1),
('8585','Happerswil',1),
('8585','Birwinken',1),
('8585','Klarsreuti',1),
('8585','Mattwil',1),
('8586','Buchackern',1),
('8586','Riedt b. Erlen',1),
('8586','Ennetaach',1),
('8586','Andwil TG',1),
('8586','Erlen',1),
('8586','Engishofen',1),
('8586','Kümmertshausen',1),
('8586','Buch b. Kümmertshausen',1),
('8588','Zihlschlacht',1),
('8589','Sitterdorf',1),
('9213','Hauptwil',1),
('9214','Kradolf',1),
('9215','Buhwil',1),
('9215','Schönenberg an der Thur',1),
('9216','Heldswil',1),
('9216','Hohentannen',1),
('9217','Neukirch an der Thur',1),
('9220','Bischofszell',1),
('9223','Schweizersholz',1),
('9223','Halden',1),
('9225','Wilen (Gottshaus)',1),
('9225','St. Pelagiberg',1),
('9503','Stehrenberg',1),
('9503','Lanterswil',1),
('9504','Friltschen',1),
('9514','Wuppenau',1),
('9515','Hosenruck',1),
('9517','Mettlen',1),
('9556','Zezikon',1),
('9556','Affeltrangen',1),
('9562','Märwil',1);

use marketdb;
insert into dbo.cities (zip_code, city_name, country_id)
values ('9562','Buch b. Märwil',1),
('9565','Schmidshof',1),
('9565','Oppikon',1),
('9565','Bussnang',1),
('9565','Rothenhausen',1),
('9565','Oberbussnang',1),
('6500','Bellinzona',1),
('6501','Bellinzona',1),
('6503','Bellinzona',1),
('6506','Bellinzona 6 Autopostale TI',1),
('6511','Cadenazzo Scanning-Center',1),
('6512','Giubiasco',1),
('6513','Monte Carasso',1),
('6514','Sementina',1),
('6515','Gudo',1),
('6517','Arbedo',1),
('6518','Gorduno',1),
('6523','Preonzo',1),
('6524','Moleno',1),
('6525','Gnosca',1),
('6528','Camorino',1),
('6532','Castione',1),
('6533','Lumino',1),
('6582','Pianezzo',1),
('6583','S. Antonio (Val Morobbia)',1),
('6584','Carena',1),
('6590','Cadenazzo Centro logistico',1),
('6590','Cadenazzo CLL AP',1),
('6592','S. Antonino',1),
('6593','Cadenazzo',1),
('6599','Robasacco',1),
('6810','Isone',1),
('6715','Dongio',1),
('6716','Leontica',1),
('6716','Acquarossa',1),
('6716','Lottigna',1),
('6717','Torre',1),
('6717','Dangio-Torre',1),
('6718','Camperio',1),
('6718','Olivone',1),
('6719','Aquila',1),
('6720','Campo (Blenio)',1),
('6720','Ghirone',1),
('6721','Motto (Blenio)',1),
('6722','Corzoneso',1),
('6723','Prugiasco',1),
('6723','Marolta',1),
('6723','Castro',1),
('6724','Largario',1),
('6724','Ponto Valentino',1),
('6742','Pollegio',1),
('6743','Bodio TI',1),
('6744','Personico',1),
('6745','Giornico',1),
('6746','Calonico',1),
('6746','Lavorgo',1),
('6746','Nivo',1),
('6747','Chironico',1),
('6748','Anzonico',1),
('6749','Cavagnago',1),
('6749','Sobrio',1),
('6760','Carì',1),
('6760','Rossura',1),
('6760','Molare',1),
('6760','Faido',1),
('6760','Campello',1),
('6760','Calpiogna',1),
('6763','Osco',1),
('6763','Mairengo',1),
('6764','Chiggiogna',1),
('6772','Rodi-Fiesso',1),
('6773','Prato (Leventina)',1),
('6774','Dalpe',1),
('6775','Ambrì',1),
('6776','Piotta',1),
('6777','Varenzo',1),
('6777','Quinto',1),
('6780','Airolo',1),
('6780','Madrano',1),
('6781','Bedretto',1),
('6781','Villa Bedretto',1),
('6516','Cugnasco',1),
('6571','Indemini',1),
('6572','Quartino',1),
('6573','Magadino',1),
('6574','Vira (Gambarogno)',1),
('6575','S. Nazzaro',1),
('6575','Vairano',1),
('6576','Gerra (Gambarogno)',1),
('6577','Ranzo',1),
('6578','Caviano',1),
('6579','Piazzogna',1),
('6594','Contone',1),
('6595','Riazzino',1),
('6596','Gordola',1),
('6597','Agarone',1),
('6598','Tenero',1),
('6600','Solduno',1),
('6600','Locarno',1),
('6600','Muralto',1),
('6601','Locarno',1),
('6602','Muralto',1),
('6604','Locarno',1),
('6605','Monte Brè sopra Locarno',1),
('6605','Locarno',1),
('6611','Crana',1),
('6611','Mosogno',1),
('6611','Gresso',1),
('6612','Ascona',1),
('6613','Porto Ronco',1),
('6614','Isole di Brissago',1),
('6614','Brissago',1),
('6616','Losone',1),
('6618','Arcegno',1),
('6622','Ronco sopra Ascona',1),
('6631','Corippo',1),
('6632','Vogorno',1),
('6633','Lavertezzo',1),
('6634','Brione (Verzasca)',1),
('6635','Gerra (Verzasca)',1),
('6636','Frasco',1),
('6637','Sonogno',1),
('6644','Orselina',1),
('6645','Brione sopra Minusio',1),
('6646','Contra',1),
('6647','Mergoscia',1),
('6648','Minusio',1),
('6652','Tegna',1),
('6653','Verscio',1),
('6654','Cavigliano',1),
('6655','Verdasio',1),
('6655','Intragna',1),
('6655','Rasa',1),
('6656','Golino',1),
('6657','Palagnedra',1),
('6658','Borgnone',1),
('6659','Camedo',1),
('6659','Moneto',1),
('6661','Berzona',1),
('6661','Loco',1),
('6661','Auressio',1),
('6662','Russo',1),
('6663','Comologno',1),
('6663','Spruga',1),
('6664','Vergeletto',1),
('6802','Rivera',1),
('6803','Camignolo',1),
('6804','Bironico',1),
('6805','Mezzovico',1),
('6806','Sigirino',1),
('6807','Taverne',1),
('6808','Torricella',1),
('6809','Medeglia',1),
('6814','Cadempino',1),
('6814','Lamone',1),
('6815','Melide',1),
('6816','Bissone',1),
('6817','Maroggia',1),
('6818','Melano',1),
('6821','Rovio',1),
('6822','Arogno',1),
('6823','Pugerna',1),
('6827','Brusino Arsizio',1),
('6867','Serpiano',1),
('6900','Massagno',1),
('6900','Paradiso',1),
('6900','Lugano',1),
('6901','Lugano',1),
('6902','Lugano 2 Paradiso Caselle',1),
('6903','Lugano',1),
('6904','Lugano 4 Molino Nuovo Casel',1),
('6905','Lugano 5 Serv Autopostali',1),
('6906','Lugano 6 Cassarate Caselle',1),
('6907','Lugano 7 Loreto Caselle',1),
('6908','Massagno Caselle',1),
('6912','Pazzallo',1),
('6913','Carabbia',1),
('6914','Carona',1),
('6915','Pambio-Noranco',1),
('6916','Grancia',1),
('6917','Barbengo',1),
('6918','Figino',1),
('6919','Carabietta',1),
('6921','Vico Morcote',1),
('6922','Morcote',1),
('6924','Sorengo',1),
('6925','Gentilino',1),
('6926','Montagnola',1),
('6927','Agra',1),
('6928','Manno',1),
('6929','Gravesano',1),
('6930','Bedano',1),
('6932','Breganzona',1),
('6933','Muzzano',1),
('6934','Bioggio',1),
('6935','Bosco Luganese',1),
('6936','Cademario',1),
('6937','Breno',1),
('6938','Fescoggia',1),
('6938','Vezio',1),
('6939','Arosio',1),
('6939','Mugena',1),
('6942','Savosa',1),
('6943','Vezia',1),
('6944','Cureglia',1),
('6945','Origlio',1),
('6946','Ponte Capriasca',1),
('6947','Vaglio',1),
('6948','Porza',1),
('6949','Comano',1),
('6950','Tesserete',1),
('6951','Signôra',1),
('6951','Odogno',1),
('6951','Cozzo',1),
('6951','Colla',1),
('6951','Insone',1),
('6951','Scareglia',1),
('6951','Bogno',1),
('6952','Canobbio',1),
('6953','Lugaggia',1),
('6954','Bigorio',1),
('6954','Sala Capriasca',1),
('6955','Cagiallo',1),
('6955','Oggio',1),
('6956','Lopagno',1),
('6957','Roveredo TI',1),
('6958','Corticiasca',1),
('6958','Bidogno',1),
('6959','Certara',1),
('6959','Cimadera',1),
('6959','Curtina',1),
('6959','Maglio di Colla',1),
('6959','Piandera Paese',1),
('6962','Viganello',1),
('6963','Cureggia',1),
('6963','Pregassona',1),
('6964','Davesco-Soragno',1),
('6965','Cadro',1),
('6966','Villa Luganese',1),
('6967','Dino',1),
('6968','Sonvico',1),
('6974','Aldesago',1),
('6976','Castagnola',1),
('6977','Ruvigliana',1),
('6978','Gandria',1),
('6979','Brè sopra Lugano',1),
('6980','Castelrotto',1),
('6981','Banco',1),
('6981','Biogno-Beride',1),
('6981','Bombinasco',1),
('6981','Bedigliora',1),
('6982','Agno',1),
('6983','Magliaso',1),
('6984','Pura',1),
('6986','Miglieglia',1),
('6986','Curio',1),
('6986','Novaggio',1),
('6987','Caslano',1),
('6988','Ponte Tresa',1),
('6989','Purasca',1),
('6990','Cassina d''Agno',1),
('6991','Neggio',1),
('6992','Vernate',1),
('6992','Cimo',1),
('6993','Iseo',1),
('6994','Aranno',1),
('6995','Madonna del Piano',1),
('6995','Molinazzo di Monteggio',1),
('6996','Ponte Cremenaga',1),
('6997','Sessa',1),
('6998','Termine',1),
('6999','Astano',1),
('6825','Capolago',1),
('6826','Riva San Vitale',1),
('6828','Balerna',1),
('6830','Chiasso',1),
('6832','Seseglio',1),
('6832','Pedrinate',1),
('6833','Vacallo',1),
('6834','Morbio Inferiore',1),
('6835','Morbio Superiore',1),
('6836','Serfontana',1),
('6837','Bruzella',1),
('6837','Caneggio',1),
('6838','Scudellate',1),
('6838','Muggio',1),
('6838','Cabbio',1),
('6839','Sagno',1),
('6850','Mendrisio',1),
('6852','Genestrerio',1),
('6853','Ligornetto',1),
('6854','S. Pietro',1),
('6855','Stabio',1),
('6862','Rancate',1),
('6863','Besazio',1),
('6864','Arzo',1),
('6865','Tremona',1),
('6866','Meride',1),
('6872','Salorino',1),
('6872','Somazzo',1),
('6873','Corteglia',1),
('6874','Castel San Pietro',1),
('6875','Casima',1),
('6875','Monte',1),
('6877','Coldrerio',1),
('6883','Novazzano',1),
('6526','Prosito',1),
('6527','Lodrino',1),
('6702','Claro',1),
('6703','Osogna',1),
('6705','Cresciano',1),
('6707','Iragna',1),
('6710','Biasca',1),
('6710','Biasca Stazione',1),
('6670','Avegno',1),
('6672','Gordevio',1),
('6673','Maggia',1),
('6674','Someo',1),
('6674','Riveo',1),
('6675','Cevio',1),
('6676','Bignasco',1),
('6677','Moghegno',1),
('6677','Aurigeno',1),
('6678','Coglio',1),
('6678','Giumaglio',1),
('6678','Lodano',1),
('6682','Linescio',1),
('6683','Niva (Vallemaggia)',1),
('6683','Cerentino',1),
('6684','Campo (Vallemaggia)',1),
('6684','Cimalmotto',1),
('6685','Bosco/Gurin',1),
('6690','Cavergno',1),
('6690','S. Carlo (Val Bavona)',1),
('6692','Brontallo',1),
('6692','Menzonio',1),
('6693','Broglio',1),
('6694','Prato-Sornico',1),
('6695','Peccia',1),
('6695','Piano di Peccia',1),
('6696','Fusio',1),
('6377','Seelisberg',1),
('6441','Rütli',1),
('6452','Sisikon',1),
('6454','Flüelen',1),
('6460','Altdorf UR',1),
('6461','Isenthal',1),
('6462','Seedorf UR',1),
('6463','Bürglen UR',1),
('6464','Spiringen',1),
('6465','Unterschächen',1),
('6466','Bauen',1),
('6467','Schattdorf',1),
('6468','Attinghausen',1),
('6469','Haldi b. Schattdorf',1),
('6472','Erstfeld',1),
('6473','Silenen',1),
('6474','Amsteg',1),
('6475','Bristen',1),
('6476','Intschi',1),
('6482','Gurtnellen',1),
('6484','Wassen UR',1),
('6485','Meien',1),
('6487','Göschenen',1),
('6490','Andermatt',1),
('6491','Realp',1),
('6493','Hospental',1),
('8751','Urnerboden',1),
('1844','Villeneuve VD',1),
('1845','Noville',1),
('1846','Chessel',1),
('1847','Rennaz',1),
('1852','Roche VD',1),
('1853','Yvorne',1),
('1854','Leysin',1),
('1856','Corbeyrier',1),
('1860','Aigle',1),
('1862','La Comballaz',1),
('1862','Les Mosses',1),
('1863','Le Sépey',1),
('1864','Vers-l''Eglise',1),
('1865','Les Diablerets',1),
('1866','La Forclaz VD',1),
('1867','Ollon VD',1),
('1867','Panex',1),
('1867','St-Triphon',1),
('1880','Les Posses-sur-Bex',1),
('1880','Les Plans-sur-Bex',1),
('1880','Fenalet-sur-Bex',1),
('1880','Frenières-sur-Bex',1),
('1880','Bex',1),
('1882','Gryon',1),
('1882','Les Posses-sur-Bex',1),
('1884','Huémoz',1),
('1884','Arveyes',1),
('1884','Villars-sur-Ollon',1),
('1885','Chesières',1),
('1892','Morcles',1),
('1892','Lavey-les-Bains',1),
('1892','Lavey-Village',1),
('1082','Corcelles-le-Jorat',1),
('1084','Carrouge VD',1),
('1085','Vulliens',1),
('1088','Ropraz',1),
('1509','Vucherens',1),
('1510','Moudon',1),
('1510','Syens',1),
('1512','Chavannes-sur-Moudon',1),
('1513','Rossenges',1),
('1513','Hermenches',1),
('1514','Bussy-sur-Moudon',1),
('1515','Villars-le-Comte',1),
('1521','Curtilles',1),
('1522','Lucens',1),
('1522','Oulens-sur-Lucens',1),
('1523','Granges-près-Marnand',1),
('1524','Marnand',1),
('1525','Henniez',1),
('1525','Seigneux',1),
('1526','Cremin',1),
('1526','Forel-sur-Lucens',1),
('1530','Payerne',1),
('1534','Sassel',1),
('1535','Combremont-le-Grand',1),
('1536','Combremont-le-Petit',1),
('1537','Champtauroz',1),
('1538','Treytorrens (Payerne)',1),
('1543','Grandcour',1),
('1545','Chevroux',1),
('1551','Vers-chez-Perrin',1),
('1552','Trey',1),
('1554','Sédeilles',1),
('1554','Rossens VD',1),
('1555','Villarzel',1),
('1562','Corcelles-près-Payerne',1),
('1565','Missy',1),
('1580','Oleyres',1),
('1580','Avenches',1),
('1582','Donatyre',1),
('1584','Villars-le-Grand',1),
('1585','Bellerive VD',1),
('1585','Cotterd',1),
('1585','Salavaux',1),
('1586','Vallamand',1),
('1587','Montmagny',1),
('1587','Constantine',1),
('1588','Cudrefin',1),
('1589','Chabrey',1),
('1595','Faoug',1),
('1682','Cerniaz VD',1),
('1682','Prévonloup',1),
('1682','Lovatens',1),
('1682','Dompierre VD',1),
('1682','Villars-Bramard',1),
('1683','Chesalles-sur-Moudon',1),
('1683','Brenles',1),
('1683','Sarzens',1),
('1787','Mur (Vully) VD',1),
('1031','Mex VD',1),
('1034','Boussens',1),
('1035','Bournens',1),
('1036','Sullens',1),
('1037','Etagnières',1),
('1038','Bercher',1),
('1040','Echallens',1),
('1040','Villars-le-Terroir',1),
('1040','St-Barthélemy VD',1),
('1041','Poliez-le-Grand',1),
('1041','Poliez-Pittet',1),
('1041','Dommartin',1),
('1041','Naz',1),
('1041','Bottens',1),
('1041','Montaubion-Chardonney',1),
('1042','Assens',1),
('1042','Bioley-Orjulaz',1),
('1042','Bettens',1),
('1043','Sugnens',1),
('1044','Fey',1),
('1045','Ogens',1),
('1046','Rueyres',1),
('1047','Oppens',1),
('1053','Bretigny-sur-Morrens',1),
('1053','Cugy VD',1),
('1054','Morrens VD',1),
('1055','Froideville',1),
('1058','Villars-Tiercelin',1),
('1059','Peney-le-Jorat',1),
('1061','Villars-Mendraz',1),
('1062','Sottens',1),
('1063','Chapelle-sur-Moudon',1),
('1063','Boulens',1),
('1063','Martherenges',1),
('1063','Peyres-Possens',1),
('1302','Vufflens-la-Ville',1),
('1303','Penthaz',1),
('1305','Penthalaz',1),
('1306','Daillens',1),
('1307','Lussery-Villars',1),
('1310','Daillens Centre Colis',1),
('1310','Daillens Dist Ba',1),
('1320','Daillens ST PP 1',1),
('1330','Daillens CALL',1),
('1375','Penthéréaz',1),
('1376','Goumoens-le-Jux',1),
('1376','Goumoens-la-Ville',1),
('1376','Eclagnens',1),
('1377','Oulens-sous-Echallens',1),
('1410','Denezy',1),
('1410','Thierrens',1),
('1410','St-Cierges',1),
('1410','Correvon',1),
('1416','Pailly',1),
('1417','Essertines-sur-Yverdon',1),
('1417','Epautheyres',1),
('1418','Vuarrens',1),
('1515','Neyruz-sur-Moudon',1),
('1148','La Praz',1),
('1321','Arnex-sur-Orbe',1),
('1322','Croy',1),
('1323','Romainmôtier',1),
('1324','Premier',1),
('1325','Vaulion',1),
('1326','Juriens',1),
('1329','Bretonnières',1),
('1337','Vallorbe',1),
('1338','Ballaigues',1),
('1341','Orient',1),
('1342','Le Pont',1),
('1343','Les Charbonnières',1),
('1344','L''Abbaye',1),
('1345','Le Lieu',1),
('1346','Les Bioux',1),
('1347','Le Solliat',1),
('1347','Le Sentier',1),
('1348','Le Brassus',1),
('1350','Orbe',1),
('1352','Agiez',1),
('1353','Bofflens',1),
('1354','Montcherand',1),
('1355','L''Abergement',1),
('1355','Sergey',1),
('1356','Les Clées',1),
('1356','La Russille',1),
('1357','Lignerolle',1),
('1358','Valeyres-sous-Rances',1),
('1372','Bavois',1),
('1373','Chavornay',1),
('1374','Corcelles-sur-Chavornay',1),
('1400','Cheseaux-Noréaz',1),
('1400','Yverdon-les-Bains',1),
('1401','Yverdon-les-Bains',1),
('1401','Yverdon Conseil et vente',1),
('1404','Villars-Epeney',1),
('1404','Cuarny',1),
('1405','Pomy',1),
('1406','Cronay',1),
('1407','Mézery-près-Donneloye',1),
('1407','Bioley-Magnoux',1),
('1407','Donneloye',1),
('1407','Gossens',1),
('1408','Prahins',1),
('1409','Chanéaz',1),
('1412','Ursins',1),
('1412','Valeyres-sous-Ursins',1),
('1413','Orzens',1),
('1415','Démoret',1),
('1415','Molondin',1),
('1420','Fiez',1),
('1421','Fontaines-sur-Grandson',1),
('1421','Grandevent',1),
('1422','Grandson',1),
('1423','Vaugondry',1),
('1423','Fontanezier',1),
('1423','Romairon',1),
('1423','Villars-Burquin',1),
('1424','Champagne',1),
('1425','Onnens VD',1),
('1426','Corcelles-près-Concise',1),
('1426','Concise',1),
('1427','Bonvillars',1),
('1428','Mutrux',1),
('1428','Provence',1),
('1429','Giez',1),
('1430','Orges',1),
('1431','Novalles',1),
('1431','Vugelles-La Mothe',1),
('1432','Belmont-sur-Yverdon',1),
('1432','Gressy',1),
('1433','Suchy',1),
('1434','Ependes VD',1),
('1435','Essert-Pittet',1),
('1436','Chamblon',1),
('1436','Treycovagnes',1),
('1437','Suscévaz',1),
('1438','Mathod',1),
('1439','Rances',1),
('1440','Montagny-Chamard',1),
('1441','Valeyres-sous-Montagny',1),
('1442','Montagny-près-Yverdon',1),
('1443','Essert-sous-Champvent',1),
('1443','Villars-sous-Champvent',1),
('1443','Champvent',1),
('1445','Vuiteboeuf',1),
('1446','Baulmes',1),
('1450','La Sagne (Ste-Croix)',1),
('1450','Le Château-de-Ste-Croix',1),
('1450','Ste-Croix',1),
('1452','Les Rasses',1),
('1453','Bullet',1),
('1453','Mauborget',1),
('1454','L''Auberson',1),
('1454','La Vraconnaz',1),
('1462','Yvonand',1),
('1463','Rovray',1),
('1464','Chêne-Pâquier',1),
('1464','Chavannes-le-Chêne',1),
('1000','Lausanne',1),
('1000','Lausanne 26',1),
('1000','Lausanne 27',1),
('1000','Lausanne 25',1),
('1001','Lausanne Sozialberatung',1),
('1001','Lausanne PF 331-140',1),
('1001','Lausanne',1),
('1001','Lausanne Arc Jurassien',1),
('1001','Lausanne PF 331-120',1),
('1002','Lausanne',1),
('1003','Lausanne',1),
('1004','Lausanne',1),
('1005','Lausanne',1),
('1006','Lausanne',1),
('1007','Lausanne',1),
('1008','Jouxtens-Mézery',1),
('1010','Lausanne',1),
('1011','Lausanne',1),
('1012','Lausanne',1),
('1014','Lausanne Adm cant VD',1),
('1017','Lausanne Charles Veillon SA',1),
('1018','Lausanne',1),
('1019','Lausanne Services spéciaux',1),
('1032','Romanel-sur-Lausanne',1),
('1033','Cheseaux-sur-Lausanne',1),
('1039','Cheseaux Polyval',1),
('1052','Le Mont-sur-Lausanne',1),
('1066','Epalinges',1),
('1009','Pully',1),
('1068','Les Monts-de-Pully',1),
('1070','Puidoux',1),
('1070','Puidoux',1),
('1071','Chexbres',1),
('1071','Rivaz',1),
('1071','St-Saphorin (Lavaux)',1),
('1072','Forel (Lavaux)',1),
('1073','Savigny',1),
('1073','Mollie-Margot',1),
('1076','Ferlens VD',1),
('1077','Servion',1),
('1078','Essertes',1),
('1080','Les Cullayes',1),
('1081','Montpreveyres',1),
('1083','Mézières VD',1),
('1090','La Croix (Lutry)',1),
('1091','Chenaux',1),
('1091','Grandvaux',1),
('1091','Aran',1),
('1092','Belmont-sur-Lausanne',1),
('1093','La Conversion',1),
('1094','Paudex',1),
('1095','Lutry',1),
('1096','Villette (Lavaux)',1),
('1096','Cully',1),
('1097','Riex',1),
('1098','Epesses',1),
('1607','Les Tavernes',1),
('1607','Palézieux',1),
('1607','Les Thioleyres',1),
('1607','Palézieux-Village',1),
('1608','Chesalles-sur-Oron',1),
('1608','Bussigny-sur-Oron',1),
('1608','Oron-le-Châtel',1),
('1610','Châtillens',1),
('1610','Vuibroye',1),
('1610','Oron-la-Ville',1),
('1612','Ecoteaux',1),
('1613','Maracon',1),
('1026','Denges',1),
('1026','Echandens',1),
('1027','Lonay',1),
('1028','Préverenges',1),
('1110','Morges',1),
('1112','Echichens',1),
('1113','St-Saphorin-sur-Morges',1),
('1114','Colombier VD',1),
('1115','Vullierens',1),
('1116','Cottens VD',1),
('1117','Grancy',1),
('1121','Bremblens',1),
('1122','Romanel-sur-Morges',1),
('1123','Aclens',1),
('1124','Gollion',1),
('1125','Monnaz',1),
('1126','Vaux-sur-Morges',1),
('1127','Clarmont',1),
('1128','Reverolle',1),
('1131','Tolochenaz',1),
('1132','Lully VD',1),
('1134','Chigny',1),
('1134','Vufflens-le-Château',1),
('1135','Denens',1),
('1136','Bussy-Chardonney',1),
('1141','Sévery',1),
('1142','Pampigny',1),
('1143','Apples',1),
('1144','Ballens',1),
('1145','Bière',1),
('1146','Mollens VD',1),
('1147','Montricher',1),
('1148','Moiry VD',1),
('1148','L''Isle',1),
('1148','La Coudre',1),
('1148','Mauraz',1),
('1148','Villars-Bozon',1),
('1148','Cuarnens',1),
('1148','Chavannes-le-Veyron',1),
('1148','Mont-la-Ville',1),
('1149','Berolle',1),
('1162','St-Prex',1),
('1163','Etoy',1),
('1164','Buchillon',1),
('1165','Allaman',1),
('1167','Lussy-sur-Morges',1),
('1168','Villars-sous-Yens',1),
('1169','Yens',1),
('1170','Aubonne',1),
('1172','Bougy-Villars',1),
('1173','Féchy',1),
('1174','Montherod',1),
('1174','Pizy',1),
('1175','Lavigny',1),
('1176','St-Livres',1),
('1187','St-Oyens',1),
('1188','Gimel',1),
('1189','Saubraz',1),
('1300','Eclépens Centre Courrier',1),
('1300','Eclépens CC Dépôt',1),
('1300','Eclépens Clinique',1),
('1300','Eclépens SAB',1),
('1300','Eclépens CC AP',1),
('1304','Cossonay-Ville',1),
('1304','Allens',1),
('1304','Senarclens',1),
('1304','Dizy',1),
('1308','La Chaux (Cossonay)',1),
('1311','Eclépens Scanning-Center',1),
('1312','Eclépens',1),
('1313','Ferreyres',1),
('1315','La Sarraz',1),
('1316','Chevilly',1),
('1317','Orny',1),
('1318','Pompaples',1),
('1166','Perroy',1),
('1180','Tartegnin',1),
('1180','Rolle',1),
('1182','Gilly',1),
('1183','Bursins',1),
('1184','Luins',1),
('1184','Vinzel',1),
('1185','Mont-sur-Rolle',1),
('1186','Essertines-sur-Rolle',1),
('1188','St-George',1),
('1195','Dully',1),
('1195','Bursinel',1),
('1196','Gland',1),
('1197','Prangins',1),
('1260','Nyon',1),
('1261','Marchissy',1),
('1261','Longirod',1),
('1261','Le Vaud',1),
('1262','Eysins',1),
('1263','Crassier',1),
('1264','St-Cergue',1),
('1265','La Cure',1),
('1266','Duillier',1),
('1267','Vich',1),
('1267','Coinsins',1),
('1268','Burtigny',1),
('1268','Begnins',1),
('1269','Bassins',1),
('1270','Trélex',1),
('1271','Givrins',1),
('1272','Genolier',1),
('1273','Le Muids',1),
('1273','Arzier',1),
('1274','Grens',1),
('1274','Signy',1),
('1275','Chéserex',1),
('1276','Gingins',1),
('1277','Borex',1),
('1277','Arnex-sur-Nyon',1),
('1278','La Rippe',1),
('1279','Bogis-Bossey',1),
('1279','Chavannes-de-Bogis',1),
('1290','Chavannes-des-Bois',1),
('1291','Commugny',1),
('1295','Mies',1),
('1295','Tannay',1),
('1296','Coppet',1),
('1297','Founex',1),
('1299','Crans-près-Céligny',1),
('1008','Prilly',1),
('1015','Lausanne',1),
('1020','Renens VD',1),
('1022','Chavannes-près-Renens',1),
('1023','Crissier',1),
('1024','Ecublens VD',1),
('1025','St-Sulpice VD',1),
('1029','Villars-Ste-Croix',1),
('1030','Bussigny-près-Lausanne',1),
('1658','La Tine',1),
('1658','Rossinière',1),
('1659','Flendruz',1),
('1659','Rougemont',1),
('1660','Château-d''Oex',1),
('1660','Les Moulins',1),
('1660','L''Etivaz',1),
('1660','La Lécherette',1),
('1800','Vevey',1),
('1801','Le Mont-Pèlerin',1),
('1802','Corseaux',1),
('1803','Chardonne',1),
('1804','Corsier-sur-Vevey',1),
('1805','Jongny',1),
('1806','St-Légier-La Chiésaz',1),
('1807','Blonay',1),
('1808','Les Monts-de-Corsier',1),
('1809','Fenil-sur-Corsier',1),
('1811','Vevey Services spéciaux',1),
('1814','La Tour-de-Peilz',1),
('1815','Clarens',1),
('1816','Chailly-Montreux',1),
('1817','Brent',1),
('1818','Montreux La Redoute',1),
('1820','Veytaux',1),
('1820','Territet',1),
('1820','Montreux',1),
('1822','Chernex',1),
('1823','Glion',1),
('1824','Caux',1),
('1832','Chamby',1),
('1832','Villard-sur-Chamby',1),
('1833','Les Avants',1),
('3900','Gamsen',1),
('3900','Brig',1),
('3900','Brigerbad',1),
('3901','Rothwald',1),
('3902','Glis',1),
('3903','Birgisch',1),
('3903','Mund',1),
('3904','Naters',1),
('3907','Gabi (Simplon)',1),
('3907','Gondo',1),
('3907','Simplon Dorf',1),
('3907','Simplon Hospiz',1),
('3911','Ried-Brig',1),
('3912','Termen',1),
('3913','Rosswald',1),
('3914','Blatten b. Naters',1),
('3914','Belalp',1),
('3939','Eggerberg',1),
('1911','Mayens-de-Chamoson',1),
('1955','Grugnay (Chamoson)',1),
('1955','St-Pierre-de-Clages',1),
('1955','Les Vérines (Chamoson)',1),
('1955','Némiaz (Chamoson)',1),
('1955','Chamoson',1),
('1957','Ardon',1),
('1963','Vétroz',1),
('1964','Conthey',1),
('1975','St-Séverin',1),
('1976','Daillon',1),
('1976','Aven',1),
('1976','Erde',1),
('1993','Clèbes (Nendaz)',1),
('1994','Aproz (Nendaz)',1),
('1996','Basse-Nendaz',1),
('1996','Saclentse',1),
('1996','Fey (Nendaz)',1),
('1996','Bieudron (Nendaz)',1),
('1996','Condémines (Nendaz)',1),
('1996','Beuson (Nendaz)',1),
('1996','Brignon (Nendaz)',1),
('1996','Baar (Nendaz)',1),
('1997','Sornard (Nendaz)',1),
('1997','Haute-Nendaz',1),
('1997','Siviez (Nendaz)',1),
('1927','Chemin',1),
('1933','Vens (Sembrancher)',1),
('1933','La Garde (Sembrancher)',1),
('1933','Chamoille (Sembrancher)',1),
('1933','Sembrancher',1),
('1934','Villette (Le Châble VS)',1),
('1934','Bruson',1),
('1934','Le Châble VS',1),
('1934','Cotterg (Le Châble VS)',1),
('1934','Montagnier (Le Châble VS)',1),
('1934','Fontenelle (Le Châble VS)',1),
('1936','Verbier',1),
('1937','Orsières',1),
('1938','Champex-Lac',1),
('1941','Cries (Vollèges)',1),
('1941','Vollèges',1),
('1942','Levron',1),
('1943','Praz-de-Fort',1),
('1944','La Fouly VS',1),
('1945','Chandonne (Liddes)',1),
('1945','Petit Vichères (Liddes)',1),
('1945','Les Moulins VS (Liddes)',1),
('1945','Fontaine Dessous (Liddes)',1),
('1945','Dranse (Liddes)',1),
('1945','Fontaine Dessus (Liddes)',1),
('1945','Rive Haute (Liddes)',1),
('1945','Vichères (Liddes)',1),
('1945','Fornex (Liddes)',1),
('1945','Chez Petit (Liddes)',1),
('1945','Palasuit (Liddes)',1),
('1945','Liddes',1),
('1946','Bourg-St-Pierre',1),
('1947','Champsec (Versegères)',1),
('1947','Prarreyer (Versegères)',1),
('1947','Versegères',1),
('1947','La Montoz (Versegères)',1),
('1947','Les Places (Versegères)',1),
('1947','Le Fregnoley (Versegères)',1),
('1948','Le Morgnes (Lourtier)',1),
('1948','Sarreyer',1),
('1948','Fionnay',1),
('1948','Le Planchamp (Lourtier)',1),
('1948','Lourtier',1),
('3801','Jungfraujoch',1),
('3984','Fieschertal',1),
('3984','Fiesch',1),
('3985','Münster VS',1),
('3985','Geschinen',1),
('3988','Ulrichen',1),
('3988','Obergesteln',1),
('3989','Biel VS',1),
('3989','Niederwald',1),
('3989','Selkingen',1),
('3989','Ritzingen',1),
('3989','Blitzingen',1),
('3994','Lax',1),
('3995','Ausserbinn',1),
('3995','Steinhaus',1),
('3995','Ernen',1),
('3995','Mühlebach (Goms)',1),
('3996','Binn',1),
('3997','Bellwald',1),
('3998','Gluringen',1),
('3998','Reckingen VS',1),
('3999','Oberwald',1),
('1961','Vernamiège',1),
('1966','Fortunau (Ayent)',1),
('1966','Saxonne (Ayent)',1),
('1966','La Place (Ayent)',1),
('1966','Blignou (Ayent)',1),
('1966','St-Romain (Ayent)',1),
('1966','Villa (Ayent)',1),
('1966','Botyre (Ayent)',1),
('1966','Argnou (Ayent)',1),
('1966','Luc (Ayent)',1),
('1966','Signèse (Ayent)',1),
('1968','Mase',1),
('1969','Eison (St.Martin)',1),
('1969','St-Martin VS',1),
('1969','Trogne (St-Martin)',1),
('1969','Liez (St-Martin)',1),
('1969','Suen (St-Martin)',1),
('1972','Anzère',1),
('1973','Nax',1),
('1981','Vex',1),
('1982','Euseigne',1),
('1983','Evolène',1),
('1983','Lana (Evolène)',1),
('1984','Les Haudères',1),
('1984','La Tour VS',1),
('1985','La Forclaz VS',1),
('1985','La Sage',1),
('1985','Villaz VS',1),
('1986','Arolla',1),
('1987','Hérémence',1),
('1988','Les Collons',1),
('1988','Thyon',1),
('1992','Les Agettes',1),
('1992','La Vernaz (Les Agettes)',1),
('1992','Crête-à-l''Oeil (Les Agettes)',1),
('1992','Les Mayens-de-Sion',1),
('3945','Gampel',1),
('3945','Niedergampel',1),
('3946','Turtmann',1);

use marketdb;
insert into dbo.cities (zip_code, city_name, country_id)
values ('3946','Gruben',1),
('3947','Ergisch',1),
('3948','Unterems',1),
('3948','Oberems',1),
('3951','Agarn',1),
('3952','Susten',1),
('3953','Inden',1),
('3953','Varen',1),
('3953','Leuk Stadt',1),
('3954','Leukerbad',1),
('3955','Albinen',1),
('3956','Guttet-Feschel',1),
('3957','Erschmatt',1),
('3957','Bratsch',1),
('3970','Salgesch',1),
('1906','Charrat',1),
('1907','Saxon',1),
('1908','Riddes',1),
('1911','Ovronnaz',1),
('1912','Dugny (Leytron)',1),
('1912','Leytron',1),
('1912','Montagnon (Leytron)',1),
('1912','Produit (Leytron)',1),
('1913','Saillon',1),
('1914','Isérables',1),
('1914','Auddes-sur-Riddes',1),
('1918','La Tzoumaz',1),
('1919','Martigny Groupe Mutuel',1),
('1920','Martigny',1),
('1921','Martigny-Croix',1),
('1926','Fully',1),
('1928','Ravoire',1),
('1929','Trient',1),
('1932','Les Valettes (Bovernier)',1),
('1932','Martigny-Croix',1),
('1868','Collombey',1),
('1870','Monthey',1),
('1871','Les Giettes',1),
('1871','Choëx',1),
('1872','Troistorrents',1),
('1873','Val-d''Illiez',1),
('1873','Champoussin',1),
('1873','Les Crosets',1),
('1874','Champéry',1),
('1875','Morgins',1),
('1893','Muraz (Collombey)',1),
('1895','Vionnaz',1),
('1896','Miex',1),
('1896','Vouvry',1),
('1897','Les Evouettes',1),
('1897','Bouveret',1),
('1898','St-Gingolph',1),
('1899','Torgon',1),
('3916','Ferden',1),
('3917','Kippel',1),
('3917','Goppenstein',1),
('3918','Wiler (Lötschen)',1),
('3919','Blatten (Lötschen)',1),
('3935','Bürchen',1),
('3938','Ausserberg',1),
('3940','Steg VS',1),
('3942','Niedergesteln',1),
('3942','Raron',1),
('3942','St. German',1),
('3943','Eischoll',1),
('3944','Unterbäch VS',1),
('3949','Hohtenn',1),
('3982','Bitsch',1),
('3983','Bister',1),
('3983','Greich',1),
('3983','Mörel',1),
('3983','Goppisberg',1),
('3983','Filet',1),
('3986','Ried-Mörel',1),
('3987','Riederalp',1),
('3991','Betten',1),
('3992','Bettmeralp',1),
('3993','Grengiols',1),
('3994','Martisberg',1),
('1869','Massongex',1),
('1890','Mex VS',1),
('1890','St-Maurice',1),
('1891','Vérossaz',1),
('1902','Evionnaz',1),
('1903','Collonges',1),
('1904','Vernayaz',1),
('1905','Dorénaz',1),
('1922','Les Granges (Salvan)',1),
('1922','Salvan',1),
('1923','Le Trétien',1),
('1923','Les Marécottes',1),
('1925','Le Châtelard VS',1),
('1925','Finhaut',1),
('1958','St-Léonard',1),
('1977','Icogne',1),
('1978','Lens',1),
('3960','Sierre',1),
('3960','Corin-de-la-Crête',1),
('3960','Niouc',1),
('3960','Loc',1),
('3960','Muraz (Sierre)',1),
('3961','Grimentz',1),
('3961','Ayer',1),
('3961','St-Jean VS',1),
('3961','Vissoie',1),
('3961','Zinal',1),
('3961','St-Luc',1),
('3961','Chandolin',1),
('3963','Crans-Montana',1),
('3963','Aminona',1),
('3963','Montana',1),
('3965','Chippis',1),
('3966','Réchy',1),
('3966','Chalais',1),
('3967','Vercorin',1),
('3968','Veyras',1),
('3971','Ollon VS',1),
('3971','Chermignon-d''en-Bas',1),
('3971','Chermignon',1),
('3972','Miège',1),
('3973','Venthône',1),
('3974','Mollens VS',1),
('3975','Randogne',1),
('3976','Champzabé',1),
('3976','Noës',1),
('3977','Granges VS',1),
('3978','Flanthey',1),
('3979','Grône',1),
('1950','Sion',1),
('1951','Sion',1),
('1951','Sion Centre logistique',1),
('1951','Sion car postal VS-Léman',1),
('1953','Sion RZ',1),
('1958','Uvrier',1),
('1962','Pont-de-la-Morge (Sion)',1),
('1965','St-Germain (Savièse)',1),
('1965','Chandolin-près-Savièse',1),
('1965','Mayens-de-la-Zour (Savièse)',1),
('1965','Granois (Savièse)',1),
('1965','Ormône (Savièse)',1),
('1965','Roumaz (Savièse)',1),
('1965','Drône VS',1),
('1965','Savièse',1),
('1965','Monteiller-Savièse',1),
('1967','Bramois',1),
('1971','Grimisuat',1),
('1971','Champlan (Grimisuat)',1),
('1974','Arbaz',1),
('1991','Pravidondaz (Salins)',1),
('1991','Arvillard (Salins)',1),
('1991','Misériez (Salins)',1),
('1991','Turin (Salins)',1),
('1991','Salins',1),
('1993','Veysonnaz',1),
('3905','Saas-Almagell',1),
('3906','Saas-Fee',1),
('3908','Saas-Balen',1),
('3910','Saas-Grund',1),
('3920','Zermatt',1),
('3922','Eisten',1),
('3922','Stalden VS',1),
('3922','Kalpetran',1),
('3923','Törbel',1),
('3924','St. Niklaus VS',1),
('3924','Gasenried',1),
('3925','Grächen',1),
('3926','Embd',1),
('3927','Herbriggen',1),
('3928','Randa',1),
('3929','Täsch',1),
('3930','Visp',1),
('3930','Eyholz',1),
('3931','Lalden',1),
('3932','Visperterminen',1),
('3933','Staldenried',1),
('3934','Zeneggen',1),
('3937','Baltschieder',1),
('6300','Zugerberg',1),
('6300','Zug',1),
('6301','Zug',1),
('6302','Zug',1),
('6303','Zug',1),
('6304','Zug',1),
('6304','Zug Bahnhof SBB',1),
('6310','Zug Sonderdienste',1),
('6312','Steinhausen',1),
('6313','Edlibach',1),
('6313','Finstersee',1),
('6313','Menzingen',1),
('6314','Unterägeri',1),
('6314','Neuägeri',1),
('6315','Oberägeri',1),
('6315','Morgarten',1),
('6315','Alosen',1),
('6317','Oberwil b. Zug',1),
('6318','Walchwil',1),
('6319','Allenwinden',1),
('6330','Cham',1),
('6331','Hünenberg',1),
('6332','Hagendorn',1),
('6333','Hünenberg See',1),
('6340','Baar',1),
('6340','Sihlbrugg',1),
('6341','Baar',1),
('6342','Baar',1),
('6343','Rotkreuz',1),
('6343','Holzhäusern ZG',1),
('6343','Risch',1),
('6343','Buonas',1),
('6345','Neuheim',1),
('6346','Baar 3 Dist Ba',1),
('6346','Baar 3',1),
('6349','Baar Sonderdienste',1),
('8143','Stallikon',1),
('8143','Uetliberg',1),
('8906','Bonstetten',1),
('8907','Wettswil',1),
('8908','Hedingen',1),
('8909','Zwillikon',1),
('8910','Affoltern am Albis',1),
('8911','Rifferswil',1),
('8912','Obfelden',1),
('8913','Ottenbach',1),
('8914','Aeugstertal',1),
('8914','Aeugst am Albis',1),
('8915','Hausen am Albis',1),
('8925','Ebertswil',1),
('8926','Hauptikon',1),
('8926','Kappel am Albis',1),
('8926','Uerzlikon',1),
('8932','Mettmenstetten',1),
('8933','Maschwanden',1),
('8934','Knonau',1),
('8212','Nohl',1),
('8245','Feuerthalen',1),
('8246','Langwiesen',1),
('8247','Flurlingen',1),
('8248','Uhwiesen',1),
('8414','Buch am Irchel',1),
('8415','Berg am Irchel',1),
('8415','Gräslikon',1),
('8416','Flaach',1),
('8444','Henggart',1),
('8447','Dachsen',1),
('8450','Andelfingen',1),
('8451','Kleinandelfingen',1),
('8452','Adlikon b. Andelfingen',1),
('8453','Alten',1),
('8457','Humlikon',1),
('8458','Dorf',1),
('8459','Volken',1),
('8460','Marthalen',1),
('8461','Oerlingen',1),
('8462','Rheinau',1),
('8463','Benken ZH',1),
('8464','Ellikon am Rhein',1),
('8465','Wildensbuch',1),
('8465','Rudolfingen',1),
('8466','Trüllikon',1),
('8467','Truttikon',1),
('8468','Guntalingen',1),
('8468','Waltalingen',1),
('8475','Ossingen',1),
('8476','Unterstammheim',1),
('8477','Oberstammheim',1),
('8478','Thalheim an der Thur',1),
('8058','Zürich',1),
('8059','Zürich 59 Exchange Office',1),
('8060','Zürich',1),
('8065','Zürich',1),
('8152','Opfikon',1),
('8152','Glattbrugg',1),
('8152','Glattpark (Opfikon)',1),
('8180','Bülach',1),
('8181','Höri',1),
('8182','Hochfelden',1),
('8183','Bülach Dist Ba',1),
('8184','Bachenbülach',1),
('8185','Winkel',1),
('8192','Zweidlen',1),
('8192','Glattfelden',1),
('8193','Eglisau',1),
('8194','Hüntwangen',1),
('8195','Wasterkingen',1),
('8196','Wil ZH',1),
('8197','Rafz',1),
('8301','Glattzentrum b. Wallisellen',1),
('8302','Kloten',1),
('8303','Bassersdorf',1),
('8304','Wallisellen',1),
('8305','Dietlikon',1),
('8309','Nürensdorf',1),
('8423','Embrach-Embraport',1),
('8424','Embrach',1),
('8425','Oberembrach',1),
('8426','Lufingen',1),
('8427','Rorbas',1),
('8427','Freienstein',1),
('8428','Teufen ZH',1),
('8105','Watt',1),
('8105','Regensdorf',1),
('8106','Adlikon b. Regensdorf',1),
('8107','Buchs ZH',1),
('8108','Dällikon',1),
('8112','Otelfingen',1),
('8113','Boppelsen',1),
('8114','Dänikon ZH',1),
('8115','Hüttikon',1),
('8153','Rümlang',1),
('8154','Oberglatt ZH',1),
('8155','Nassenwil',1),
('8155','Niederhasli',1),
('8156','Oberhasli',1),
('8157','Dielsdorf',1),
('8158','Regensberg',1),
('8162','Steinmaur',1),
('8162','Sünikon',1),
('8164','Bachs',1),
('8165','Oberweningen',1),
('8165','Schöfflisdorf',1),
('8165','Schleinikon',1),
('8166','Niederweningen',1),
('8172','Niederglatt ZH',1),
('8173','Neerach',1),
('8174','Stadel b. Niederglatt',1),
('8175','Windlach',1),
('8187','Weiach',1),
('8340','Hinwil',1),
('8342','Wernetshausen',1),
('8343','Hinwil Dist Ba',1),
('8344','Bäretswil',1),
('8345','Adetswil',1),
('8496','Steg im Tösstal',1),
('8497','Fischenthal',1),
('8498','Gibswil',1),
('8607','Aathal-Seegräben',1),
('8608','Bubikon',1),
('8614','Bertschikon (Gossau ZH)',1),
('8620','Wetzikon ZH',1),
('8621','Wetzikon ZH 4',1),
('8622','Wetzikon ZH',1),
('8623','Wetzikon ZH',1),
('8624','Grüt (Gossau ZH)',1),
('8625','Gossau ZH',1),
('8626','Ottikon (Gossau ZH)',1),
('8627','Grüningen',1),
('8630','Rüti ZH',1),
('8632','Tann',1),
('8633','Wolfhausen',1),
('8635','Dürnten',1),
('8636','Wald ZH',1),
('8637','Laupen ZH',1),
('8639','Faltigberg',1),
('8134','Adliswil',1),
('8135','Langnau am Albis',1),
('8135','Sihlwald',1),
('8135','Sihlbrugg Station',1),
('8136','Gattikon',1),
('8800','Thalwil',1),
('8801','Thalwil Fächer',1),
('8802','Kilchberg ZH',1),
('8803','Rüschlikon',1),
('8804','Au ZH',1),
('8805','Richterswil',1),
('8810','Horgen',1),
('8812','Horgen Bahnhof Oberdorf',1),
('8813','Horgen',1),
('8815','Horgenberg',1),
('8816','Hirzel',1),
('8820','Wädenswil',1),
('8824','Schönenberg ZH',1),
('8825','Hütten',1),
('8833','Samstagern',1),
('8942','Oberrieden',1),
('8125','Zollikerberg',1),
('8126','Zumikon',1),
('8130','Zumikon Yves Rocher SA',1),
('8618','Oetwil am See',1),
('8634','Hombrechtikon',1),
('8700','Küsnacht ZH',1),
('8702','Zollikon',1),
('8703','Erlenbach ZH',1),
('8704','Herrliberg',1),
('8706','Meilen',1),
('8707','Uetikon am See',1),
('8708','Männedorf',1),
('8712','Stäfa',1),
('8713','Uerikon',1),
('8714','Feldbach',1),
('8307','Ottikon b. Kemptthal',1),
('8307','Effretikon',1),
('8308','Illnau',1),
('8308','Agasul',1),
('8310','Grafstal',1),
('8310','Kemptthal',1),
('8312','Winterberg ZH',1),
('8314','Kyburg',1),
('8315','Lindau',1),
('8317','Tagelswangen',1),
('8320','Fehraltorf',1),
('8322','Gündisau',1),
('8322','Madetswil',1),
('8325','Effretikon Dist Ba',1),
('8330','Hermatswil',1),
('8330','Pfäffikon ZH',1),
('8331','Auslikon',1),
('8332','Russikon',1),
('8332','Rumlikon',1),
('8335','Hittnau',1),
('8484','Neschwil',1),
('8484','Weisslingen',1),
('8484','Theilingen',1),
('8489','Wildberg',1),
('8492','Wila',1),
('8493','Saland',1),
('8494','Bauma',1),
('8499','Sternenberg',1),
('8044','Gockhausen',1),
('8117','Fällanden',1),
('8118','Pfaffhausen',1),
('8121','Benglen',1),
('8122','Binz',1),
('8123','Ebmatingen',1),
('8124','Maur',1),
('8127','Forch',1),
('8132','Hinteregg',1),
('8132','Egg b. Zürich',1),
('8133','Esslingen',1),
('8306','Brüttisellen',1),
('8600','Dübendorf',1),
('8602','Wangen b. Dübendorf',1),
('8603','Schwerzenbach',1),
('8604','Volketswil',1),
('8605','Gutenswil',1),
('8606','Nänikon',1),
('8606','Greifensee',1),
('8610','Uster',1),
('8612','Uster 2',1),
('8613','Uster 3',1),
('8614','Sulzbach',1),
('8615','Wermatswil',1),
('8615','Freudwil',1),
('8616','Riedikon',1),
('8617','Mönchaltorf',1),
('8311','Brütten',1),
('8352','Ricketwil (Winterthur)',1),
('8352','Elsau',1),
('8353','Elgg',1),
('8354','Hofstetten ZH',1),
('8400','Winterthur',1),
('8401','Winterthur',1),
('8402','Winterthur',1),
('8404','Stadel (Winterthur)',1),
('8404','Reutlingen (Winterthur)',1),
('8404','Winterthur',1),
('8405','Winterthur',1),
('8406','Winterthur',1),
('8408','Winterthur',1),
('8409','Winterthur',1),
('8410','Winterthur',1),
('8411','Winterthur',1),
('8412','Hünikon (Neftenbach)',1),
('8412','Riet (Neftenbach)',1),
('8412','Aesch (Neftenbach)',1),
('8413','Neftenbach',1),
('8418','Schlatt b. Winterthur',1),
('8421','Dättlikon',1),
('8422','Pfungen',1),
('8442','Hettlingen',1),
('8471','Rutschwil (Dägerlen)',1),
('8471','Dägerlen',1),
('8471','Oberwil (Dägerlen)',1),
('8471','Bänk (Dägerlen)',1),
('8471','Berg (Dägerlen)',1),
('8472','Seuzach',1),
('8474','Dinhard',1),
('8479','Altikon',1),
('8482','Sennhof (Winterthur)',1),
('8483','Kollbrunn',1),
('8486','Rikon im Tösstal',1),
('8487','Rämismühle',1),
('8487','Zell ZH',1),
('8488','Turbenthal',1),
('8495','Schmidrüti',1),
('8523','Hagenbuch ZH',1),
('8542','Wiesendangen',1),
('8543','Bertschikon',1),
('8543','Kefikon ZH',1),
('8543','Gundetswil',1),
('8544','Attikon',1),
('8545','Rickenbach ZH',1),
('8545','Rickenbach Sulz',1),
('8546','Menzengrüt',1),
('8548','Ellikon an der Thur',1),
('8010','Zürich BZ Annahme',1),
('8010','Zürich CS Annahme',1),
('8010','Zürich Briefzentrum',1),
('8010','Zürich-Mülligen SPS AG',1),
('8010','Zürich BZ FP',1),
('8010','Zürich Kanton Annahme',1),
('8010','Zürich BZI DE',1),
('8010','Zürich BZ Brieflklinik',1),
('8010','Zürich',1),
('8010','Zürich Helsana Annahme',1),
('8010','Zürich-Mülligen BZI',1),
('8011','Zürich Mülligen SC',1),
('8012','Zürich',1),
('8015','Zürich 15',1),
('8080','Zürich PV',1),
('8102','Oberengstringen',1),
('8103','Unterengstringen',1),
('8104','Weiningen ZH',1),
('8142','Uitikon Waldegg',1),
('8901','Urdorf RRD',1),
('8902','Urdorf',1),
('8903','Birmensdorf ZH',1),
('8904','Aesch ZH',1),
('8951','Fahrweid',1),
('8952','Schlieren',1),
('8953','Dietikon',1),
('8954','Geroldswil',1),
('8955','Oetwil an der Limmat',1),
('8970','Urdorf Exchange',1),
('8000','Zürich',1),
('8001','Zürich',1),
('8002','Zürich',1),
('8003','Zürich',1),
('8004','Zürich',1),
('8005','Zürich',1),
('8006','Zürich',1),
('8008','Zürich',1),
('8016','Zürich 16 Zustellung',1),
('8020','Zürich 1',1),
('8021','Zürich 1 Sihlpost',1),
('8021','Zürich 1',1),
('8022','Zürich',1),
('8023','Zürich',1),
('8024','Zürich',1),
('8026','Zürich',1),
('8027','Zürich',1),
('8030','Zürich',1),
('8031','Zürich',1),
('8032','Zürich',1),
('8033','Zürich',1),
('8034','Zürich',1),
('8036','Zürich Corona',1),
('8036','Zürich',1),
('8037','Zürich',1),
('8038','Zürich',1),
('8039','Zürich',1),
('8040','Zürich',1),
('8041','Zürich',1),
('8042','Zürich',1),
('8044','Zürich',1),
('8045','Zürich',1),
('8046','Zürich',1),
('8047','Zürich',1),
('8048','Zürich',1),
('8049','Zürich',1),
('8050','Zürich',1),
('8051','Zürich',1),
('8052','Zürich',1),
('8053','Zürich',1),
('8055','Zürich',1),
('8057','Zürich',1),
('8059','Zürich 59 Ausland',1),
('8061','Zürich',1),
('8063','Zürich',1),
('8064','Zürich',1),
('8066','Zürich',1),
('8068','Zürich',1),
('8070','Zürich',1),
('8071','Zürich CS PZ',1),
('8074','Zürich Voice Publishing',1),
('8075','Zürich Benissimo spezial',1),
('8080','Zürich West SPS',1),
('8080','Zürich 80',1),
('8081','Zürich Helsana',1),
('8085','Zürich Versicherung',1),
('8086','Zürich Reader''s Digest',1),
('8087','Zürich',1),
('8088','Zürich',1),
('8090','Zürich',1),
('8091','Zürich',1),
('8092','Zürich ETH-Zentrum',1),
('8093','Zürich ETH-Hönggerberg',1),
('8096','Zürich IBRS local',1),
('8098','Zürich',1),
('8099','Zürich Sonderdienste',1),
('6713','Malvaglia',1),
('6714','Semione',1),
('6721','Ludiano',1),
('6911','Campione d''Italia',1),
('8238','Büsingen',1),
('9489','Schaan Log',1);

use marketdb;
insert into dbo.rent_prices (rent_price)
values (450),
    (500);

use marketdb;
insert into dbo.locations (streetname,
                          location_capacity,
                          location_name,
                          city_id,
                          country_id,
						  rent_price_id)
values ('Markstrasse',300,'Testmarkt',5,1,1),
    ('Teststrasse',450,'Testmark2',6,1,2);

use marketdb;
insert into dbo.persons (salutation_id,
                        firstname,
                        lastname,
                        date_of_birth,
                        streetname,
                        streetnumber,
                        city_id,
                        country_id)
values (1,'Max','Muster','1989-07-31','Musterstrasse',3,4,1),
    (2,'Hannah','Muster','1988-05-08','Beispielstrasse',13,6,1);

-- insert members without person reference
use marketdb;
insert into dbo.members (email_address,
                        password)
values ('test_member@gmail.com',123456),
    ('full_member@gmail.com',123456);

-- insert member with person reference
use marketdb;
insert into dbo.members (email_address,
                        password,
                        member_status_id,
                        person_id)
values ('person@gmail.com',123456,2,1),
    ('hannah.muster@gmail.com0',123456,3,2);

